;*********************************************************************************************
;** Original File: F:\nes_disasm\Super Dodge Ball (U).nes
;** 16K PRG-ROM pages: $08
;** 8K CHR-ROM pages: $10
;** Mirroring: horizontal
;** SRAM: not available
;** Trainer: not available
;** Mapper: $01
;*********************************************************************************************

; in this bank, it's highly probable that #$f9 and #$fa represent the energy
; tiles in the status bar.

.autoimport +

;The following labels are referenced by other banks:

	.export Lbl_8000, Lbl_8006, Lbl_8009, Lbl_800c, Lbl_800f, Lbl_8012, Lbl_8015, Lbl_8018
	.export Lbl_801b, Lbl_801e, Lbl_8024, Lbl_8027, Lbl_802a, Lbl_802d, Lbl_8050, Lbl_80bb
	.export Lbl_80bf, Lbl_81cd, Lbl_81d8, Lbl_81f9, Lbl_82b7, Lbl_82b9, Lbl_82c5, Lbl_82d1
	.export PlayerHPVals, Lbl_8321, Lbl_8375, Lbl_8376, Lbl_8377, Lbl_8500, Lbl_856c, Lbl_8578
	.export Lbl_8629, Lbl_8674, Lbl_8692, Lbl_8719, Lbl_871a, Lbl_87c8, Lbl_87c9, Lbl_883e
	.export Lbl_88dd, Lbl_891d, Lbl_893a, Lbl_89e0, Lbl_89e4, Lbl_8a1d, Lbl_8a55, Lbl_8e12
	.export Lbl_8e33, Lbl_8ebf, Lbl_8f25, Lbl_8f4c, Lbl_8f4d, Lbl_8f5e, Lbl_8f5f, Lbl_8f70
	.export Lbl_9022, Lbl_9023, Lbl_9056, Lbl_905f, Lbl_9068, Lbl_9086, Lbl_90b2, Lbl_90ef
	.export Lbl_9163, Lbl_918a, Lbl_9193, Lbl_91e4, Lbl_930f, Lbl_95eb, Lbl_9611, Lbl_9612
	.export Lbl_96ab, Lbl_9710, Lbl_9765, Lbl_97a6, Lbl_97a8, Lbl_97aa, Lbl_97b4, Lbl_97d1
	.export Lbl_9805, Lbl_9806, Lbl_983f, Lbl_9883, Lbl_98b7, Lbl_98b8, Lbl_98f0, Lbl_98f9
	.export Lbl_99cc, Lbl_9a20, Lbl_9a82, Lbl_9ad0, Lbl_9b0c, Lbl_9b48, Lbl_9ba6, Lbl_9ba7
	.export Lbl_9c09, Lbl_9c0a, Lbl_9c0d, Lbl_9c0e, Lbl_9c4f, Lbl_9c50, Lbl_9c53, Lbl_9c54
	.export Lbl_9c57, Lbl_9c67, Lbl_9c99, Lbl_9cf0, Lbl_9cf1, Lbl_9e10, Lbl_9e11, Lbl_9e14
	.export Lbl_9e57, Lbl_9e75, Lbl_9e76, Lbl_9ebd, Lbl_9ebe, Lbl_9ec1, Lbl_9ece, Lbl_9f1e
	.export Lbl_9f46, Lbl_9f74, Lbl_9f75, Lbl_9fe2, Lbl_a006, Lbl_a007, Lbl_a1ee, Lbl_a212
	.export Lbl_a275, Lbl_a289, Lbl_a2c8, Lbl_a348, Lbl_a354, Lbl_a360, Lbl_a399, Lbl_a3a1
	.export Lbl_a3cc, Lbl_a3cd, Lbl_a3fc, Lbl_a40d, Lbl_a41e, Lbl_a42f, Lbl_a440, Lbl_a451
	.export Lbl_a462, Lbl_a473, Lbl_a484, Lbl_a500, Lbl_a501, Lbl_a504, Lbl_a505, Lbl_a54c
	.export Lbl_a5a1, Lbl_a669, Lbl_a66a, Lbl_a67b, Lbl_a6ca, Lbl_a6cb, Lbl_a800, Lbl_a82b
	.export Lbl_a831, Lbl_a890, Lbl_a8b8, Lbl_a9ff, Lbl_aa98, Lbl_aaf6, Lbl_ab02, Lbl_ab1d
	.export Lbl_ab5d, Lbl_ab5e, Lbl_ace9, Lbl_ad6b, Lbl_ae7b, Lbl_aeac, Lbl_aead, Lbl_aef4
	.export Lbl_af01, Lbl_af02, Lbl_af19, Lbl_af32, Lbl_b004

.segment "PRG_4"

Lbl_8000:
	jmp Lbl_8e12

Lbl_8003:		; might be code
	;.byte $4c,$99,$83
	jmp $8399

Lbl_8006:
	jmp Lbl_8050

Lbl_8009:
	jmp Lbl_8500

Lbl_800c:
	jmp Lbl_856c

Lbl_800f:
	jmp Lbl_8629

Lbl_8012:
	jmp Lbl_8674

Lbl_8015:
	jmp Lbl_871a

Lbl_8018:
	jmp Lbl_8692

Lbl_801b:
	jmp Lbl_a831

Lbl_801e:
	jmp Lbl_ace9

Lbl_8021:		; might be code
	;.byte $4c,$80,$8d
	jmp $8d80

Lbl_8024:
	jmp Lbl_9a20

Lbl_8027:
	jmp Lbl_91e4

Lbl_802a:
	jmp Lbl_930f

Lbl_802d:
	jmp Lbl_96ab

Lbl_8030:		; might be code
	;.byte $4c,$60,$8a
	jmp $8a60
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

Lbl_8050:
	bit $76			; shadow team match
	bpl Lbl_805f	; branch if positive
	ldx #$05

Lbl_8056:
	lda $06f0,x
	sta $06f6,x
	dex 
	bpl Lbl_8056

Lbl_805f:
	ldx #$01
	bit $70
	bvc Lbl_8072	; branch if overflow set
	ldx #$00
	lda #$aa
	sta $61
	lda #$82
	sta $62
	jmp Lbl_807f

Lbl_8072:
	txa
	asl a 
	tay 
	lda Lbl_80bb,y
	sta $61
	lda Lbl_80bc,y
	sta $62

Lbl_807f:
	ldy #$05

Lbl_8081:
	lda ($61),y
	pha 
	stx a:$006a
	sty a:$006b
	tya 
	cpx #$00
	beq Lbl_8092
	clc 
	adc #$06

Lbl_8092:
	tay 
	pla 
	jsr Lbl_80bf
	jsr Lbl_8321
	ldx $6a
	ldy $6b
	dey 
	bpl Lbl_8081
	bit $70
	bvs Lbl_80af	; branch if overflow set
	dex 
	bpl Lbl_8072
	lda #$03		; 3 players per team in normal modes
	sta $80			; players alive on P2 team
	sta $81			; players alive on P1 team
	rts 

Lbl_80af:		; bean ball mode player setup
	lda #$06		; 6 players for bean ball mode
	sec				; set carry
	sbc $6f			; subtract number of human players
	sta $80			; set players alive on CPU side
	lda $6f			; number of human players
	sta $81			; set players alive on Human side
	rts 

Lbl_80bb:
	.byte $f6

Lbl_80bc:
	.byte $06,$f0,$06

Lbl_80bf:
	sta $4f
	stx $50
	sty $51
	jsr Lbl_c988
	lda #$00
	ldy $51

Lbl_80cc:
	dey 
	bmi Lbl_80d4
	clc 
	adc #$04
	bpl Lbl_80cc

Lbl_80d4:
	sta $53
	ldy #$37
	lda #$00

Lbl_80da:
	sta ($4d),y
	dey 
	bpl Lbl_80da
	lda #$80
	ldy #$00
	sta ($4d),y
	lda $4f
	beq Lbl_80ec
	sec 
	sbc #$01

Lbl_80ec:
	sta $52
	asl a 
	asl a 
	asl a 
	asl a 
	ldx $53
	sta $91,x
	ldx $50
	lda $7a,x		; p2 or p1 team, depending on X
	and #$80		; get control bit
	lsr a
	lsr a
	ora $52
	sta $52
	bit $70
	bvc Lbl_816c	; branch if overflow clear
	ldx a:$006f		; number of human players
	dex

Lbl_810a:
	lda a:$0086,x
	cmp $51
	bne Lbl_8130
	ldy #$2e
	inx 
	txa
	ora #$40
	sta ($4d),y
	ldy #$00
	lda ($4d),y
	ora #$40
	sta ($4d),y
	dex 
	lda $52
	ora Lbl_81d4,x
	ora #$20
	ora #$80
	sta $52
	jmp Lbl_813b

Lbl_8130:
	dex 
	bpl Lbl_810a
	lda $52
	and #$df
	and #$7f
	sta $52

Lbl_813b:
	ldx $50
	lda $52
	and #$bf
	ldy #$02
	sta ($4d),y
	ldy #$02
	ldx $4f
	lda ($4d),y
	and #$20
	beq Lbl_8151
	ldx #$06

Lbl_8151:
	lda Lbl_82b0,x
	cmp #$0f
	beq Lbl_815f
	sta $54
	jsr Lbl_830d
	lda $54

Lbl_815f:
	ldx $53
	ora $91,x
	sta $91,x
	ldy #$02
	lda ($4d),y
	jmp Lbl_8188

Lbl_816c:
	lda $52
	ora Lbl_82b7,x
	sta $52
	ldy $51
	lda Lbl_82b9,y
	ora $52
	and #$e7
	ldx $50
	cpx #$01
	beq Lbl_8184
	ora #$08

Lbl_8184:
	ldy #$02
	sta ($4d),y

Lbl_8188:
	ldx $50
	ldy #$02
	lda ($4d),y
	and #$07
	tay 
	lda $7a,x		; p2 or p1 team, depending on X
	bit $76			; shadow team match
	bpl Lbl_8199	; branch if positive
	lda #$00

Lbl_8199:
	and #$0f
	clc 
	adc Lbl_82d1,y		; index into a table of offsets of 9
	tay 
	lda PlayerHPVals,y	; get energy amount
	ldy #$04
	sta ($4d),y
	jsr Lbl_81d8
	ldy $51
	lda Lbl_82c5,y
	ldy #$03
	sta ($4d),y
	bit $70
	bvs Lbl_81cd		; branch if overflow set
	ldx $53
	ora $91,x
	sta $91,x
	ldy #$2e
	lda $50
	eor #$01
	clc 
	adc #$01
	ora ($4d),y
	sta ($4d),y
	jmp Lbl_81cd

Lbl_81cd:
	lda $4f
	ldx $50
	ldy $51
	rts 

Lbl_81d4:
	.byte $00,$08,$10,$18

Lbl_81d8:
	lda $4f
	asl a 
	asl a 
	asl a 
	sta $54
	lda $70
	and #$60		; mask #$60
	bne Lbl_8200	; branch if not ??
	lda $7a,x		; p2 or p1 team, depending on X
	and #$7f
	cpx #$00
	bne Lbl_81f9	; branch if x != 0x00?
	bit $76			; shadow team match
	bpl Lbl_81f6	; branch if positive
	lda $77
	jmp Lbl_81f9

Lbl_81f6:
	sec				; set carry
	sbc #$01

Lbl_81f9:
	ora $54
	ldy #$2c
	sta ($4d),y
	rts 

Lbl_8200:
	bit $70
	bvc Lbl_8214	; branch if overflow clear
	lda $7a,x		; p2 or p1 team, depending on X
	and #$7f		; strip control bit
	beq Lbl_820d	; branch if equal
	sec
	sbc #$01

Lbl_820d:
	ora $54
	ldy #$2c
	sta ($4d),y
	rts 

Lbl_8214:
	lda $4f
	beq Lbl_821c
	cmp #$01
	bne Lbl_823b

Lbl_821c:
	lda a:$007b		; p1 team
	and #$0f		; get team part
	pha
	lda a:$007a		; p2 team
	and #$0f		; get team part
	tay
	pla
	clc
	adc Lbl_8250,y		; offsets of 9, used for indexing into Lbl_8259
	tay
	lda Lbl_8259,y		; 9x9 table of values and other crap
	cpx #$01
	beq Lbl_8239		; branch if x == 0x01
	lsr a
	lsr a
	lsr a
	lsr a

Lbl_8239:
	and #$0f

Lbl_823b:
	asl a 
	asl a 
	asl a 
	sta $54
	lda $7a,x		; p2 or p1 team, depending on X
	and #$7f		; strip away player control bit
	beq Lbl_8249	; branch if both teams are the same?
	sec				; set carry
	sbc #$01

Lbl_8249:
	ora $54
	ldy #$2c
	sta ($4d),y
	rts 

Lbl_8250:		; Offsets of 9, used for indexing into Lbl_8259
	.byte $00,$09,$12,$1b,$24,$2d,$36,$3f,$48

Lbl_8259:		; 9x9 table and some other values
	.byte $00,$01,$01,$01,$01,$01,$01,$01,$01
	.byte $10,$11,$01,$01,$01,$01,$01,$01,$01
	.byte $10,$10,$11,$01,$11,$10,$11,$10,$01
	.byte $10,$10,$10,$11,$10,$10,$10,$10,$11
	.byte $10,$10,$11,$01,$11,$10,$11,$10,$01
	.byte $10,$10,$01,$01,$01,$11,$01,$11,$01
	.byte $10,$10,$11,$01,$11,$10,$11,$10,$01
	.byte $10,$10,$01,$01,$01,$11,$01,$11,$01
	.byte $10,$10,$10,$11,$10,$10,$10,$10,$11
	;--;
	.byte $00,$04,$03,$02,$06,$05

Lbl_82b0:
	.byte $04,$05,$0f,$0f,$00,$01,$0f

Lbl_82b7:
	.byte $00,$80

Lbl_82b9:	; xref'd in Lbl_816c
	.byte $40,$40,$40,$00,$00,$00,$40,$40,$40,$00,$00,$00

Lbl_82c5:	; xref'd in Lbl_8199
	.byte $00,$02,$04,$06,$08,$0a,$01,$03,$05,$07,$09,$0b

Lbl_82d1:	; Offsets of 9, used for indexing into PlayerHPVals.
	.byte $00,$09,$12,$1b,$24,$2d

PlayerHPVals:	; Energy Amounts
	;team:USA,Pro,Eng,Ind,Ice,Chi,Jpn,Ken,Rus
	.byte $28,$24,$30,$14,$40,$28,$38,$2c,$3c ; Type A
	.byte $20,$18,$28,$10,$34,$24,$2c,$24,$38 ; Type D
	.byte $1c,$14,$24,$10,$30,$24,$28,$20,$38 ; Type C
	.byte $1c,$10,$24,$10,$2c,$24,$24,$20,$38 ; Type B
	.byte $24,$1c,$2c,$10,$38,$24,$30,$28,$38 ; Type F
	.byte $20,$18,$28,$10,$34,$24,$2c,$24,$38 ; Type E

Lbl_830d:
	ldx a:$006f		; number of human players
	dex

Lbl_8311:
	lda a:$0086,x
	cmp $54
	beq Lbl_831c
	dex 
	bpl Lbl_8311
	rts 

Lbl_831c:
	lda #$0f
	sta $54
	rts 

Lbl_8321:
	bit $70
	bvs Lbl_8344	; branch if overflow set
	tya 
	sta $4d
	asl a 
	adc $4d
	tax
	jsr Lbl_c988
	ldy #$30
	lda Lbl_8375,x
	sta ($4d),y
	iny 
	lda Lbl_8376,x
	sta ($4d),y
	ldy #$33
	lda Lbl_8377,x
	sta ($4d),y
	rts 

Lbl_8344:
	tya 
	sta $4d
	asl a 
	adc $4d
	tax
	jsr Lbl_c988
	ldy #$30
	lda Lbl_8363,x
	sta ($4d),y
	iny 
	lda Lbl_8364,x
	sta ($4d),y
	ldy #$33
	lda Lbl_8365,x
	sta ($4d),y
	rts 

Lbl_8363:
	.byte $e0

Lbl_8364:
	.byte $00

Lbl_8365:
	.byte $58,$20,$01,$58,$b0,$00,$34,$50,$01,$34,$e0,$00,$10,$20,$01,$10

Lbl_8375:
	.byte $b0

Lbl_8376:
	.byte $00

Lbl_8377:
	.byte $6a,$b0,$00,$10,$43,$00,$40,$90,$01,$40,$30,$01,$30,$30,$01,$50
	.byte $50,$01,$6a,$50,$01,$10,$bd,$01,$40,$70,$00,$40,$d0,$00,$30,$d0
	.byte $00,$50,$60,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00

Lbl_8500:
	lda #$1f
	sta $61
	lda #$03
	sta $62
	ldx #$00

Lbl_850a:
	ldy #$00
	lda ($61),y
	bpl Lbl_8514
	and #$02
	beq Lbl_851a

Lbl_8514:
	lda #$f0
	ora $91,x
	sta $91,x

Lbl_851a:
	bit $70
	bvc Lbl_853c
	lda $91,x
	bmi Lbl_853c
	and #$0f
	cmp #$0f
	beq Lbl_853c
	tay 
	jsr Lbl_c988
	ldy #$00
	lda ($4d),y
	bpl Lbl_8536
	and #$02
	beq Lbl_853c

Lbl_8536:
	lda #$0f
	ora $91,x
	sta $91,x

Lbl_853c:
	ldy #$30
	lda ($61),y
	sta $92,x
	iny 
	lda ($61),y
	sta $93,x
	ldy #$33
	lda ($61),y
	sta $94,x
	lda #$38
	clc 
	adc $61
	sta $61
	lda $62
	adc #$00
	sta $62
	inx 
	inx 
	inx 
	inx 
	bit $70
	bvc Lbl_8567
	cpx #$18
	bcc Lbl_850a
	rts 

Lbl_8567:
	cpx #$30
	bcc Lbl_850a
	rts 

Lbl_856c:
	lda #$0b
	sta $51
	lda #$1f
	sta $61
	lda #$03
	sta $62

Lbl_8578:
	lda #$00
	sta $4d
	ldy #$30
	lda $e1
	sec 
	sbc ($61),y
	sta $4e
	iny 
	lda $e2
	sbc ($61),y
	iny 
	pha 
	and #$ff
	bmi Lbl_8596
	lda #$80
	sta $4d
	bne Lbl_85a5

Lbl_8596:
	lda $4e
	eor #$ff
	clc 
	adc #$01
	sta $4e
	pla 
	eor #$ff
	adc #$00
	pha 

Lbl_85a5:
	pla 
	beq Lbl_85ac
	lda #$ff
	sta $4e

Lbl_85ac:
	ldy #$33
	lda $e4
	sec 
	sbc ($61),y
	sta $4f
	iny 
	lda $e5
	sbc ($61),y
	iny 
	pha 
	and #$ff
	bpl Lbl_85d5
	lda #$40
	ora $4d
	sta $4d
	lda $4f
	eor #$ff
	clc 
	adc #$01
	sta $4f
	pla 
	eor #$ff
	adc #$00
	pha 

Lbl_85d5:
	pla 
	beq Lbl_85dc
	lda #$ff
	sta $4f

Lbl_85dc:
	ldy #$36
	lda $e7			; Ball Height 2
	sec 
	sbc ($61),y
	sta $50
	iny 
	lda $e8
	sbc ($61),y
	iny 
	pha 
	and #$ff
	bpl Lbl_85ff
	lda $50
	eor #$ff
	clc 
	adc #$01
	sta $50
	pla 
	eor #$ff
	adc #$00
	pha 

Lbl_85ff:
	pla 
	beq Lbl_8606
	lda #$ff
	sta $50

Lbl_8606:
	ldx #$00
	ldy #$10

Lbl_860a:
	lda $4d,x
	sta ($61),y
	inx 
	iny 
	cpx #$04
	bcc Lbl_860a
	lda $61
	clc 
	adc #$38
	sta $61
	lda $62
	adc #$00
	sta $62
	dec $51
	bmi Lbl_8628
	jmp Lbl_8578

Lbl_8628:
	rts 

Lbl_8629:
	bit $78
	bvc Lbl_8673
	lda $8a
	cmp #$06
	bcc Lbl_863b
	ldx #$00
	lda #$03
	sta $03
	bne Lbl_8641

Lbl_863b:
	ldx #$01
	lda #$09
	sta $03

Lbl_8641:
	lda #$03
	sta $04

Lbl_8645:
	ldy $03
	jsr Lbl_c988
	ldy #$00
	lda ($4d),y
	bpl Lbl_8669
	and #$02
	bne Lbl_8669
	lda $03
	jsr Lbl_cb65
	ldy $03
	cpx #$00
	bne Lbl_8665
	cmp #$07
	beq Lbl_8671
	bne Lbl_8669

Lbl_8665:
	cmp #$06
	beq Lbl_8671

Lbl_8669:
	inc $03
	dec $04
	bne Lbl_8645
	ldy #$ff

Lbl_8671:
	sty $8b,x

Lbl_8673:
	rts 

Lbl_8674:
	bit $78
	bvc Lbl_867e
	lda $c5
	and #$7f
	beq Lbl_8681

Lbl_867e:
	jmp Lbl_8719

Lbl_8681:
	ldy $8f
	cpy #$ff
	beq Lbl_8692
	jsr Lbl_c988
	ldy #$01
	lda ($4d),y
	and #$bf
	sta ($4d),y

Lbl_8692:
	lda $8a
	asl a 
	asl a 
	tax
	lda $91,x
	and #$0f
	cmp #$06
	bcc Lbl_86a5
	lda #$ff
	sta $8f
	bne Lbl_8719

Lbl_86a5:
	lsr a
	lda #$02
	sta $00
	bcs Lbl_86bd
	lda #$00
	sta $01
	ldx #$03
	stx $8f
	inx 
	stx $02
	ldx #$0c
	ldy #$10
	bne Lbl_86cc

Lbl_86bd:
	lda #$01
	sta $01
	ldx #$09
	stx $8f
	inx 
	stx $02
	ldx #$24
	ldy #$28

Lbl_86cc:
	lda $91,x
	and #$f0
	cmp #$f0
	beq Lbl_86fc
	stx $03
	tya 
	tax
	lda $91,x
	ldx $03
	and #$f0
	cmp #$f0
	beq Lbl_8702
	inx 
	lda $91,x
	dex 
	stx $03
	sty $04
	inc $04
	ldx $04
	cmp $91,x
	ldx $03
	lda $01
	bne Lbl_86fa
	bcc Lbl_8702
	bcs Lbl_86fc

Lbl_86fa:
	bcs Lbl_8702

Lbl_86fc:
	lda $02
	sta $8f
	tya 
	tax

Lbl_8702:
	iny 
	iny 
	iny 
	iny 
	inc $02
	dec $00
	bne Lbl_86cc
	ldy $8f
	jsr Lbl_c988
	ldy #$01
	lda ($4d),y
	ora #$40
	sta ($4d),y

Lbl_8719:
	rts 

Lbl_871a:
	lda $c5
	and #$7f
	bne Lbl_8726
	ldy $8a
	cpy #$ff
	bne Lbl_8729

Lbl_8726:
	jmp Lbl_87c8

Lbl_8729:
	jsr Lbl_c988
	ldy #$09
	lda ($4d),y
	and #$7f
	cmp #$0a
	beq Lbl_8726
	ldy #$02
	lda ($4d),y
	and #$20
	beq Lbl_8726
	lda ($4d),y
	sta $17			; it looks like this is the only time $17 is written to.
	iny 
	lda ($4d),y
	sta $18
	ldy #$19
	lda ($4d),y
	sta $2e
	ldy #$2d
	lda ($4d),y
	sta $42
	ldy #$30
	lda ($4d),y
	sta $45
	iny 
	lda ($4d),y
	sta $46
	iny 
	iny 
	lda ($4d),y
	sta $48
	iny 
	lda ($4d),y
	sta $49
	ldy #$01
	lda ($4d),y
	and #$01
	bne Lbl_877f
	lda #$df
	ldx #$21
	bit $70
	bvc Lbl_878b
	lda #$df
	ldx #$21
	bne Lbl_878b

Lbl_877f:
	lda #$df
	ldx #$21
	bit $70
	bvc Lbl_878b
	lda #$df
	ldx #$21

Lbl_878b:
	sta $0c
	stx $0d
	ldy $8d
	cpy #$ff
	beq Lbl_87a0
	jsr Lbl_c988
	ldy #$01
	lda ($4d),y
	and #$df
	sta ($4d),y

Lbl_87a0:
	ldx #$00
	bit $70
	bvs Lbl_87b0
	bit $17
	bmi Lbl_87ae
	ldx #$09
	bne Lbl_87b0

Lbl_87ae:
	ldx #$03

Lbl_87b0:
	stx $03
	jsr Lbl_87c9
	sta $8d
	bcs Lbl_87c5
	tay 
	jsr Lbl_c988
	ldy #$01
	lda ($4d),y
	ora #$20
	sta ($4d),y

Lbl_87c5:
	jsr Lbl_883e

Lbl_87c8:
	rts 

Lbl_87c9:
	lda #$00
	sta $04
	inc $04
	sta $05
	sta $07
	tax
	lda #$03
	bit $70
	bvc Lbl_87dc
	lda #$06

Lbl_87dc:
	sta $06

Lbl_87de:
	ldy $03
	cpy $8a
	beq Lbl_8813
	jsr Lbl_c988
	ldy #$00
	lda ($4d),y
	bpl Lbl_8813
	and #$02
	bne Lbl_8813
	lda $03
	jsr Lbl_c9cf
	sta $55,x
	lda $2e
	clc 
	adc $0d
	cmp $55,x
	bmi Lbl_8813
	sec 
	sbc $0d
	sec 
	sbc $0d
	cmp $55,x
	bpl Lbl_8813
	lda $04
	ora $05
	sta $05
	inc $07

Lbl_8813:
	inx 
	inc $03
	asl $04
	dec $06
	bne Lbl_87de
	lda $07
	bne Lbl_8825
	lda #$ff
	sec 
	bne Lbl_883d

Lbl_8825:
	cmp #$01
	bne Lbl_8839

Lbl_8829:
	lda $04
	cmp $05
	beq Lbl_8835
	lsr $04
	dec $03
	bne Lbl_8829

Lbl_8835:
	lda $03
	bne Lbl_883c

Lbl_8839:
	jsr Lbl_89e0

Lbl_883c:
	clc 

Lbl_883d:
	rts 

Lbl_883e:
	ldy $8e
	cpy #$ff
	beq Lbl_884f
	jsr Lbl_c988
	ldy #$01
	lda ($4d),y
	and #$fb
	sta ($4d),y

Lbl_884f:
	bit $70
	bvc Lbl_885d	; branch if overflow clear
	lda #$00
	sta $03
	jsr Lbl_891d
	sta $8e
	rts 

Lbl_885d:
	lda #$00
	sta $0f
	lda $18
	cmp #$06
	bcc Lbl_88a6
	lsr a
	lda $42
	bcs Lbl_8870
	bpl Lbl_8872
	bmi Lbl_888b

Lbl_8870:
	bpl Lbl_888b

Lbl_8872:
	bit $17
	bmi Lbl_887c
	lda #$03
	ldx #$14
	bne Lbl_8880

Lbl_887c:
	lda #$09
	ldx #$2c

Lbl_8880:
	sta $03
	jsr Lbl_891d
	bcc Lbl_88c8
	lda #$ff
	sta $0f

Lbl_888b:
	lda $18
	and #$01
	bne Lbl_8899
	bit $42
	bmi Lbl_88a3
	lda #$01
	bne Lbl_889f

Lbl_8899:
	bit $42
	bpl Lbl_88a3
	lda #$00

Lbl_889f:
	ldx #$ff
	stx $0f

Lbl_88a3:
	clc 
	adc #$06

Lbl_88a6:
	ldx #$00
	tay 
	beq Lbl_88b3
	txa
	clc 

Lbl_88ad:
	adc #$08
	dey 
	bne Lbl_88ad
	tax

Lbl_88b3:
	lda $2e
	clc 
	rol a 
	rol a 
	rol a 
	rol a 
	stx $00
	adc $00
	tax
	lda Lbl_88dd,x
	cmp #$ff
	bne Lbl_88c8
	lda $8f

Lbl_88c8:
	sta $8e
	ldx $0f
	cpx #$ff
	beq Lbl_88dc
	tay 
	jsr Lbl_c988
	ldy #$01
	lda ($4d),y
	ora #$04
	sta ($4d),y

Lbl_88dc:
	rts 

Lbl_88dd:
	.byte $00,$00,$00,$ff,$01,$02,$00,$00,$00,$00,$00,$08,$07,$ff,$00,$00
	.byte $00,$ff,$00,$00,$00,$00,$00,$02,$06,$08,$00,$00,$00,$00,$00,$ff
	.byte $00,$00,$ff,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$ff,$06
	.byte $00,$06,$08,$07,$01,$01,$02,$00,$06,$06,$08,$07,$07,$01,$02,$00

Lbl_891d:
	lda #$00
	sta $04
	inc $04
	sta $05
	sta $07
	tax
	lda #$03
	bit $70
	bvc Lbl_8938	; branch if overflow clear
	lda #$f0
	sta $0c
	lda #$10
	sta $0d
	lda #$05

Lbl_8938:
	sta $06

Lbl_893a:
	ldy $03
	cpy $8a
	beq Lbl_89b2
	jsr Lbl_c988
	ldy #$00
	lda ($4d),y
	bpl Lbl_89b2
	and #$02
	bne Lbl_89b2
	lda ($4d),y
	and #$04
	bne Lbl_89b2
	ldy #$02
	bit $70
	bvc Lbl_8961	; branch if overflow clear
	lda ($4d),y
	and #$20
	beq Lbl_89b2
	bne Lbl_8980

Lbl_8961:
	lda $03
	jsr Lbl_cb65
	bit $17
	bmi Lbl_8976
	cmp #$06
	bne Lbl_89b2
	ldy #$10
	lda ($4d),y
	bmi Lbl_89b2
	bpl Lbl_8980

Lbl_8976:
	cmp #$07
	bne Lbl_89b2
	ldy #$10
	lda ($4d),y
	bpl Lbl_89b2

Lbl_8980:
	lda $03
	jsr Lbl_c9cf
	sta $55,x
	bit $70
	bvc Lbl_89aa
	lda $2e
	bne Lbl_899b
	lda $55,x
	cmp $0c
	bcs Lbl_89aa
	cmp $0d
	bcc Lbl_89aa
	bcs Lbl_89b2

Lbl_899b:
	sec 
	sbc $0d
	cmp $55,x
	bcs Lbl_89b2
	adc $0d
	adc $0d
	cmp $55,x
	bcc Lbl_89b2

Lbl_89aa:
	lda $04
	ora $05
	sta $05
	inc $07

Lbl_89b2:
	inx 
	inc $03
	asl $04
	dec $06
	beq Lbl_89be
	jmp Lbl_893a

Lbl_89be:
	lda $07
	bne Lbl_89c7
	lda #$ff
	sec 
	bne Lbl_89df

Lbl_89c7:
	cmp #$01
	bne Lbl_89db

Lbl_89cb:
	lda $04
	cmp $05
	beq Lbl_89d7
	lsr $04
	dec $03
	bne Lbl_89cb

Lbl_89d7:
	lda $03
	bne Lbl_89de

Lbl_89db:
	jsr Lbl_89e0

Lbl_89de:
	clc 

Lbl_89df:
	rts 

Lbl_89e0:
	lda #$ff
	sta $62

Lbl_89e4:
	lda $04
	and $05
	bne Lbl_89ed
	jmp Lbl_8a55

Lbl_89ed:
	ldy $03
	jsr Lbl_c988
	lda $2e
	cmp $55,x
	bcs Lbl_89fa
	adc #$20

Lbl_89fa:
	and #$40
	beq Lbl_8a0f
	ldy #$30
	lda ($4d),y
	sec 
	sbc $45
	sta $63
	iny 
	lda ($4d),y
	sbc $46
	jmp Lbl_8a1d

Lbl_8a0f:
	ldy #$33
	lda ($4d),y
	sec 
	sbc $48
	sta $63
	iny 
	lda ($4d),y
	sbc $49

Lbl_8a1d:
	sta $64
	bpl Lbl_8a34
	eor #$ff
	sta $64
	lda $63
	eor #$ff
	clc 
	adc #$01
	sta $63
	lda $64
	adc #$00
	sta $64

Lbl_8a34:
	lda $62
	cmp #$ff
	beq Lbl_8a45
	lda $61
	sec 
	sbc $63
	lda $62
	sbc $64
	bcc Lbl_8a51

Lbl_8a45:
	lda $03
	sta $06
	lda $63
	sta $61
	lda $64
	sta $62

Lbl_8a51:
	dec $07
	beq Lbl_8a5d

Lbl_8a55:
	lsr $04
	dec $03
	dex 
	jmp Lbl_89e4

Lbl_8a5d:
	lda $06
	rts 

Lbl_8a60:
	.byte $a5,$c5,$29,$7f,$d0,$05,$a4,$8a,$4c,$7a,$8a,$c9,$03,$d0,$05,$a4
	.byte $8e,$4c,$7a,$8a,$c9,$04,$d0,$06,$a4,$8d,$c0,$06,$90,$28,$a0,$06
	.byte $20,$88,$c9,$a5,$d3,$18,$69,$10,$29,$e0,$a9,$19,$91,$4d,$a0,$30
	.byte $a5,$e1,$91,$4d,$c8,$a5,$e2,$91,$4d,$c8,$c8,$a5,$e4,$91,$4d,$c8
	.byte $a5,$e5,$91,$4d,$a0,$06,$8c,$fd,$06,$20,$88,$c9,$a5,$4d,$85,$4f
	.byte $a5,$4e,$85,$50,$a0,$19,$b1,$4d,$85,$00,$a9,$00,$85,$01,$a9,$06
	.byte $85,$02,$a4,$01,$20,$88,$c9,$a2,$00,$86,$04,$a0,$02,$b1,$4d,$29
	.byte $07,$85,$05,$0a,$0a,$0a,$18,$65,$05,$aa,$a0,$30,$b1,$4d,$38,$f1
	.byte $4f,$85,$61,$c8,$b1,$4d,$f1,$4f,$10,$11,$49,$7f,$85,$62,$a5,$61
	.byte $49,$ff,$18,$69,$01,$85,$61,$a5,$62,$69,$00,$85,$62,$29,$7f,$f0
	.byte $0a,$a9,$ff,$85,$61,$a5,$62,$29,$80,$85,$62,$a9,$05,$85,$05,$a5
	.byte $61,$dd,$bd,$8b,$90,$07,$e6,$04,$e8,$c6,$05,$d0,$f4,$8a,$18,$65
	.byte $05,$aa,$a0,$33,$b1,$4f,$38,$f1,$4d,$85,$63,$c8,$b1,$4f,$f1,$4d
	.byte $10,$11,$49,$7f,$85,$64,$a5,$63,$49,$ff,$18,$69,$01,$85,$63,$a5
	.byte $64,$69,$00,$85,$64,$29,$7f,$f0,$0a,$a9,$ff,$85,$63,$a5,$64,$29
	.byte $80,$85,$64,$a9,$04,$85,$05,$a5,$63,$dd,$bd,$8b,$90,$11,$e6,$04
	.byte $e6,$04,$e6,$04,$e6,$04,$e6,$04,$e6,$04,$e8,$c6,$05,$d0,$ea,$a6
	.byte $04,$bd,$f3,$8b,$85,$03,$a5,$64,$4a,$05,$62,$48,$a5,$00,$d0,$07
	.byte $68,$29,$40,$d0,$25,$f0,$19,$c9,$80,$b0,$07,$68,$29,$80,$f0,$1a
	.byte $d0,$0e,$d0,$07,$68,$29,$40,$f0,$11,$d0,$05,$68,$29,$80,$d0,$0a
	.byte $e6,$03,$e6,$03,$a5,$03,$09,$80,$85,$03,$a0,$15,$a5,$03,$91,$4d
	.byte $e6,$01,$c6,$02,$f0,$03,$4c,$c2,$8a,$20,$11,$8c,$60,$00,$3c,$48
	.byte $5c,$70,$00,$1e,$24,$2e,$14,$30,$40,$4c,$58,$0c,$18,$20,$26,$00
	.byte $54,$68,$74,$90,$00,$2a,$34,$3a,$20,$6c,$70,$80,$a0,$10,$38,$38
	.byte $40,$00,$44,$4c,$60,$78,$00,$22,$26,$30,$10,$28,$60,$70,$80,$08
	.byte $14,$30,$38,$00,$01,$02,$03,$04,$05,$01,$01,$02,$03,$04,$05,$02
	.byte $02,$02,$03,$04,$05,$03,$03,$03,$03,$04,$05,$04,$04,$04,$04,$04
	.byte $05,$ac,$fd,$06,$20,$88,$c9,$a5,$4d,$85,$4f,$a5,$4e,$85,$50,$a9
	.byte $00,$85,$00,$a9,$06,$85,$01,$a4,$00,$20,$88,$c9,$a0,$02,$b1,$4d
	.byte $29,$20,$d0,$1c,$b1,$4d,$29,$07,$0a,$85,$02,$0a,$18,$65,$02,$aa
	.byte $a9,$ff,$85,$02,$20,$57,$8c,$20,$8a,$8c,$a5,$02,$a0,$03,$91,$4d
	.byte $e6,$00,$c6,$01,$d0,$d1,$60,$a0,$33,$b1,$4f,$dd,$b5,$8c,$b0,$04
	.byte $a9,$f0,$d0,$09,$b1,$4f,$dd,$b4,$8c,$b0,$06,$a9,$fc,$25,$02,$85
	.byte $02,$bd,$b7,$8c,$d1,$4f,$b0,$04,$a9,$0f,$d0,$09,$bd,$b6,$8c,$d1
	.byte $4f,$b0,$06,$a9,$3f,$25,$02,$85,$02,$60,$a0,$30,$b1,$4f,$38,$fd
	.byte $b8,$8c,$c8,$b1,$4f,$e9,$00,$b0,$06,$a9,$55,$25,$02,$85,$02,$88
	.byte $bd,$b9,$8c,$38,$f1,$4f,$c8,$a9,$01,$f1,$4f,$b0,$06,$a9,$aa,$25
	.byte $02,$85,$02,$60,$2c,$1a,$34,$46,$90,$70,$28,$18,$38,$48,$88,$78
	.byte $3c,$22,$24,$3e,$b0,$50,$40,$24,$20,$3c,$b8,$48,$2e,$1b,$32,$45
	.byte $94,$6c,$38,$20,$28,$40,$a8,$58,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $a5,$70,$29,$60,$d0,$11,$a5,$78,$29,$04,$d0,$0b,$ad,$9a,$06,$0d
	.byte $99,$06,$0d,$98,$06,$d0,$01,$60,$ce,$98,$06,$d0,$5d,$ad,$99,$06
	.byte $20,$fb,$8d,$8d,$99,$06,$ad,$9a,$06,$d0,$11,$a2,$39,$ad,$99,$06
	.byte $f0,$06,$c9,$10,$b0,$06,$a2,$38,$aa,$20,$15,$fa,$ad,$99,$06,$c9
	.byte $59,$d0,$09,$ad,$9a,$06,$20,$fb,$8d,$8d,$9a,$06,$ad,$99,$06,$0d
	.byte $9a,$06,$0d,$98,$06,$d0,$1e,$a5,$78,$29,$d9,$85,$78,$a9,$04,$a6
	.byte $80,$e4,$81,$b0,$02,$a9,$06,$05,$78,$29,$df,$09,$80,$85,$78,$a9
	.byte $01,$8d,$98,$06,$60,$a9,$14,$8d,$98,$06,$60,$f0,$12,$38,$e9,$01
	.byte $48,$29,$0f,$c9,$0f,$d0,$06,$68,$29,$f0,$09,$09,$48,$68,$60,$a9
	.byte $59,$60

Lbl_8e12:
	lda $70
	and #$20		; mask #$20 (versus mode?)
	bne Lbl_8e19	; branch if not equal
	rts 

Lbl_8e19:
	lda #$00
	sta $0587		; bean ball #players
	sta $0588
	sta $0589
	sta $058a
	sta $058b		; Player 1-1 Energy?
	sta a:$00c2
	sta a:$00c3
	sta a:$00c4

Lbl_8e33:
	jsr Lbl_fe8a
	jsr Lbl_fcb5
	jsr Lbl_db2e
	jsr Lbl_dbf1
	lda #$0f
	jsr Lbl_fa65

	; set PPUADDR to $2268
	lda #$22
	sta $2006		; PPUADDR
	lda #$68
	sta $2006		; PPUADDR
	; write tile #$B8
	lda #$b8
	sta $2007		; PPUDATA

	; set PPUADDR to $2277
	lda #$22
	sta $2006		; PPUADDR
	lda #$77
	sta $2006		; PPUADDR
	; write tile #$B8
	lda #$b8
	sta $2007		; PPUDATA

	lda #$ff
	sta $069d		; (player color dupe?)
	jsr Lbl_9023
	lda #$00
	sta $0437
	sta $046f
	sta $04a7
	sta $04d7
	sta $069e
	ldx #$00
	jsr Lbl_90ef
	ldx #$01
	jsr Lbl_90ef
	ldx #$00
	lda #$3f
	jsr Lbl_9086
	ldx #$01
	lda #$3f
	jsr Lbl_9086
	jsr Lbl_db4e
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr Lbl_fcbf
	lda #$29
	jsr sub_PlaySound	; play song #$29 (bean ball)
	lda #$00
	sta $069e
	lda #$04
	sta $0617
	lda #$00
	sta $067a
	sta $067b
	jsr Lbl_fba4
	jsr Lbl_fa50
	jsr Lbl_dbdb

Lbl_8ebf:
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda $069e
	and #$03
	beq Lbl_8edc
	cmp #$01
	beq Lbl_8ef8
	cmp #$02
	beq Lbl_8f07
	bne Lbl_8f1c

Lbl_8edc:
	lda #$04
	sta $0617
	lda #$00
	sta $067a
	sta $067b
	jsr Lbl_fd5d
	jsr Lbl_8f70
	jsr Lbl_9068
	jsr Lbl_db4e
	jmp Lbl_8f25

Lbl_8ef8:
	jsr Lbl_8f70
	jsr Lbl_9068
	jsr Lbl_db4e
	jsr Lbl_9163
	jmp Lbl_8f25

Lbl_8f07:
	lda $70
	ora #$02
	sta $70
	jsr Lbl_df58
	lda $70
	and #$fd		; mask #$fd
	sta $70
	jsr Lbl_db4e
	jmp Lbl_8f25

Lbl_8f1c:
	jsr Lbl_fba4
	jsr Lbl_fa50
	jsr Lbl_dbdb

Lbl_8f25:
	inc $069e
	lda $069e
	and #$03
	bne Lbl_8ebf
	lda $f5			; player 1 trigger input
	and #$20		; select button
	beq Lbl_8f3b	; branch if equal
	jsr Lbl_99cc
	jmp Lbl_8e33

Lbl_8f3b:
	lda $0588
	and $0589
	bmi Lbl_8f46
	jmp Lbl_8ebf

Lbl_8f46:
	lda #$00
	jsr sub_PlaySound	; play a song/sound effect
	rts 

Lbl_8f4c:
	.byte $e4

Lbl_8f4d:
	.byte $28,$24,$29,$64,$29,$a4,$29,$e4,$29,$24,$2a,$64,$2a,$a4,$2a,$e4
	.byte $2a

Lbl_8f5e:
	.byte $f3

Lbl_8f5f:
	.byte $28,$33,$29,$73,$29,$b3,$29,$f3,$29,$33,$2a,$73,$2a,$b3,$2a,$f3
	.byte $2a

Lbl_8f70:
	lda $069e
	and #$01
	sta $0587		; set bean ball #players
	ldx $0587		; bean ball #players
	lda $f5,x		; P1/P2 trigger input
	and #$dc
	bne Lbl_8f84
	jmp Lbl_9022

Lbl_8f84:
	tay 
	and #$80
	beq Lbl_8f9e
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	lda $0588,x
	ora #$80
	sta $0588,x
	lda #$3f
	jsr Lbl_9086
	jmp Lbl_9022

Lbl_8f9e:
	tya 
	and #$40
	beq Lbl_8fb8
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	lda $0588,x
	and #$7f
	sta $0588,x
	lda #$00
	jsr Lbl_9086
	jmp Lbl_9022

Lbl_8fb8:
	tya 
	and #$08
	beq Lbl_8fe2
	lda $0588,x
	bmi Lbl_9022
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	lda #$00
	jsr Lbl_9086
	jsr Lbl_90b2
	dec $058a,x
	bpl Lbl_8fd9
	lda #$08
	sta $058a,x

Lbl_8fd9:
	jsr Lbl_90ef
	jsr Lbl_9023
	jmp Lbl_9022

Lbl_8fe2:
	tya 
	and #$04
	beq Lbl_9011
	lda $0588,x
	bmi Lbl_9022
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	lda #$00
	jsr Lbl_9086
	jsr Lbl_90b2
	inc $058a,x
	lda $058a,x
	cmp #$09
	bcc Lbl_9008
	lda #$00
	sta $058a,x

Lbl_9008:
	jsr Lbl_90ef
	jsr Lbl_9023
	jmp Lbl_9022

Lbl_9011:
	lda $0588
	ora #$80
	sta $0588
	lda $0589
	ora #$80
	sta $0589
	rts 

Lbl_9022:
	rts 

Lbl_9023:		; versus play(?) team setting and such
	ldx $058a		; Team Cursor P1
	lda Lbl_9056,x	; use p1 cursor pos as index into Lbl_9056
	ora #$80		; add human control
	sta $7b			; set P1 Team
	ldx $058b		; Team Cursor P2
	lda Lbl_9056,x	; use p2 cursor pos as index into Lbl_9056
	ora #$80		; add human control
	sta $7a			; set P2 Team
	; set up palettes
	lda $7a			; get P2 Team
	and #$0f		; strip control byte
	tax
	lda Lbl_905f,x	; use P2 team & 0x0F as index into Lbl_905f
	asl a 
	asl a 
	asl a 
	asl a 
	sta $4d			; save P2's value later for combining
	lda $7b			; P1 Team
	and #$0f		; strip control byte
	tax
	lda Lbl_905f,x	; use P1 team & 0x0F as index into Lbl_905f
	ora $4d			; OR it by P2's value (combining!)
	sta $06fc		; set VS. match Character Color
	sta $069c		; set Normal match Character Color
	rts 

Lbl_9056:		; VS. Mode Team Order
	.byte $00,$01,$02,$03,$04,$05,$07,$06,$08

Lbl_905f:		; VS. Mode Team Palettes
	.byte $00,$01,$02,$03,$04,$05,$08,$07,$06

Lbl_9068:
	ldy #$00
	lda $069e
	and #$04
	beq Lbl_9073
	ldy #$3f

Lbl_9073:
	sty $4e
	lda $069e
	and #$01
	tax
	lda $0588,x
	bmi Lbl_9085
	lda $4e
	jsr Lbl_9086

Lbl_9085:
	rts 

Lbl_9086:
	pha 
	lda $058a,x
	asl a 
	tay 
	cpx #$01
	beq Lbl_90a1
	lda Lbl_8f4d,y
	sta $2006		; PPUADDR
	lda Lbl_8f4c,y
	sta $2006		; PPUADDR
	pla 
	sta $2007		; PPUDATA
	rts 

Lbl_90a1:
	lda Lbl_8f5f,y
	sta $2006		; PPUADDR
	lda Lbl_8f5e,y
	sta $2006		; PPUADDR
	pla 
	sta $2007		; PPUDATA
	rts 

Lbl_90b2:
	lda $06ed,x
	bpl Lbl_90ee
	lda $058a,x
	asl a 
	tay 
	lda Lbl_991f,y
	sta $61
	lda Lbl_9920,y
	sta $62
	cpx #$01
	beq Lbl_90dc
	lda Lbl_8f4d,y
	sta $2006		; PPUADDR
	lda Lbl_8f4c,y
	clc 
	adc #$01
	sta $2006		; PPUADDR
	jmp Lbl_90eb

Lbl_90dc:
	lda Lbl_8f5f,y
	sta $2006		; PPUADDR
	lda Lbl_8f5e,y
	clc 
	adc #$01
	sta $2006		; PPUADDR

Lbl_90eb:
	jmp Lbl_9130

Lbl_90ee:
	rts 

Lbl_90ef:
	lda $06ed,x
	bmi Lbl_90f5
	rts 

Lbl_90f5:
	lda #$bf
	cpx #$01
	clc 
	bne Lbl_90fe
	adc #$08

Lbl_90fe:
	sta $61
	lda #$05
	adc #$00
	sta $62
	lda $058a,x
	asl a 
	tay 
	cpx #$01
	beq Lbl_9121
	lda Lbl_8f4d,y
	sta $2006		; PPUADDR
	lda Lbl_8f4c,y
	clc 
	adc #$01
	sta $2006		; PPUADDR
	jmp Lbl_9130

Lbl_9121:
	lda Lbl_8f5f,y
	sta $2006		; PPUADDR
	lda Lbl_8f5e,y
	clc 
	adc #$01
	sta $2006		; PPUADDR

Lbl_9130:
	ldy #$00
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	rts 

; Lbl_9163
Lbl_9163:
	lda a:$007b		; P1 Team
	and #$0f
	pha
	lda a:$007a		; P2 Team
	and #$0f
	tay
	pla
	clc
	adc Lbl_918a,y	; get the base offset into Lbl_9193
	tay
	lda Lbl_9193,y	; get the specified CHR bank value from the table.
	cmp $06af		; compare to the value at (Current left/sprite CHR bank dupe?)
	beq Lbl_9189	; branch if equal; no need to set again.
	sta $06ae		; set current Left/Sprite CHR bank
	sta $06af		; set (current Left/Sprite CHR bank dupe?)
	lda $06ae		; load current Left/Sprite CHR bank
	jsr MMC1_SetCHRBank0		; set chr bank 0 based on value at $06ae

Lbl_9189:
	rts
;-- end subroutine --;

Lbl_918a:		; offsets into below table
	.byte $00,$09,$12,$1b,$24,$2d,$36,$3f,$48

Lbl_9193:		; 9x9 table used for sprite CHR banks. see also: bank 7 Lbl_f695
	;vs.  USA,Pro,Eng,Ind,Ice,Chi,Jpn,Ken,USSR
	.byte $0d,$10,$0d,$0e,$0d,$13,$0d,$13,$0e		; Team USA
	.byte $10,$10,$11,$12,$11,$16,$11,$16,$12		; Pro All-Stars
	.byte $0d,$11,$0d,$0f,$0d,$14,$0d,$14,$0f		; England
	.byte $0e,$12,$0f,$0e,$0f,$15,$0f,$15,$0e		; India
	.byte $0d,$11,$0d,$0f,$0d,$14,$0d,$14,$0f		; Iceland
	.byte $13,$16,$14,$15,$14,$13,$14,$13,$15		; China
	.byte $0d,$11,$0d,$0f,$0d,$14,$0d,$14,$0f		; Japan
	.byte $13,$16,$14,$15,$14,$13,$14,$13,$15		; Kenya
	.byte $0e,$12,$0f,$0e,$0f,$15,$0f,$15,$0e		; USSR

Lbl_91e4:
	bit $70
	bvs Lbl_91e9	; branch if overflow set
	rts 

Lbl_91e9:
	lda #$00
	sta $0587		; set bean ball #players = 0

Lbl_91ee:
	lda #$00
	sta $031f
	jsr Lbl_fe8a
	jsr Lbl_fcb5
	jsr Lbl_db2e
	jsr Lbl_dbf1
	jsr Lbl_fcb5
	lda $70
	ora #$02
	sta $70
	lda #$10
	jsr Lbl_fa65
	lda $70
	and #$fd		; mask #$fd
	sta $70
	jsr Lbl_95eb
	jsr Lbl_db4e
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr Lbl_fcbf
	jsr Lbl_9982
	lda #$29
	jsr sub_PlaySound	; play song #$29 (bean ball)

Lbl_922a:
	lda #$04
	sta $0617
	lda #$00
	sta $067a
	sta $067b
	inc $069e
	jsr Lbl_fda6
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_929c
	jsr Lbl_92dc	; update bean ball #players cursor tile
	jsr Lbl_db4e
	jsr Lbl_fbc6
	jsr Lbl_fa50
	jsr Lbl_dbdb
	lda $f7			; P1 input
	ora $f5			; player 1 trigger input
	and #$20		; select button
	beq Lbl_928e	; branch if equal
	jsr Lbl_dbf1
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda #$00
	jsr Lbl_af32

Lbl_9274:
	jsr Lbl_fda6
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda $f7			; P1 input
	ora $f5			; player 1 trigger input
	and #$a0		; select or A?
	beq Lbl_9274
	jmp Lbl_91ee

Lbl_928e:
	lda $f7			; P1 input
	ora $f5			; player 1 trigger input
	and #$d0		; B, A, or Start?
	beq Lbl_922a
	lda #$00
	jsr sub_PlaySound	; play a song/sound effect
	rts 

; bean ball: modified to support 4 players (again).
; thanks to rahga for finding this originally
Lbl_929c:
	lda $f7			; P1 input
	ora $f5			; player 1 trigger input
	and #$0c		; strip to up/down
	beq Lbl_92db
	pha
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	pla
	and #$04
	beq Lbl_92c6	; branch if pressed up
	lda #$00
	jsr Lbl_92ec	; update bean ball #players cursor
	inc $0587		; bean ball #players++
	lda $0587		; load bean ball #players
	cmp #$04		; number of bean ball player entries (originally #$02)
	bcc Lbl_92d5	; branch if carry clear
	lda #$00
	sta $0587		; set bean ball #players = 0
	jmp Lbl_92d5

Lbl_92c6:
	lda #$00
	jsr Lbl_92ec	; update bean ball #players cursor
	dec $0587		; bean ball #players--
	bpl Lbl_92d5	; branch if positive
	lda #$03		; was #$01 (to go to 2p instead of 4p)
	sta $0587		; set bean ball #players (4 here, 2 in original)

Lbl_92d5:
	ldx $0587		; load bean ball #players
	inx				; increment
	stx $6f			; store number of human players in zeropage

Lbl_92db:
	rts
;-- end subroutine --;

;-- Lbl_92dc --;
Lbl_92dc:
	ldy #$00
	lda $069e
	and #$10
	beq Lbl_92e7	; branch if equal (blank out tile)
	ldy #$3f		; tile #$3f (cursor)

Lbl_92e7:
	tya
	jsr Lbl_92ec	; update bean ball #players cursor
	rts
;-- end subroutine --;

; Lbl_92ec
; Update cursor on Bean Ball number of players screen. (A = tile to write)
Lbl_92ec:
	pha
	lda $0587		; load bean ball #players for index into tables
	asl a
	tay
	lda Lbl_9307,y	; bean ball #players cursor nametable pos 1
	sta $4d
	lda Lbl_9308,y	; bean ball #players cursor nametable pos 2
	sta $2006		; PPUADDR
	lda $4d
	sta $2006		; PPUADDR
	pla
	sta $2007		; PPUDATA
	rts
;-- end subroutine --;

	; $294b		"1 Player" cursor nametable loc
	; $298b		"2 Players" cursor nametable loc
	; $29cb		"3 Players" cursor nametable loc
	; $2a0b		"4 Players" cursor nametable loc
Lbl_9307:		; bean ball #players cursor nametable pos 1
	.byte $4b

Lbl_9308:		; bean ball #players cursor nametable pos 2
	.byte $29, $8b,$29, $cb,$29, $0b,$2a

Lbl_930f:		; called from Lbl_802a (so likely from another bank)
	bit $70
	bvs Lbl_9314	; branch if overflow set
	rts

Lbl_9314:
	jsr Lbl_fe8a
	jsr Lbl_fcb5
	jsr Lbl_db2e
	jsr Lbl_dbf1
	lda #$12
	jsr Lbl_fa65
	jsr Lbl_9632
	jsr Lbl_db4e
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr Lbl_fcbf
	lda #$29
	jsr sub_PlaySound	; play song #$29 (bean ball)
	lda #$00
	sta $031f
	sta $0357
	sta $038f
	sta $03c7
	sta $03ff
	sta $0437
	jsr Lbl_93df

Lbl_9350:
	lda #$04
	sta $0617
	lda #$00
	sta $067a
	sta $067b
	jsr Lbl_fa00
	inc $069e
	lda $069e
	and #$03
	bne Lbl_936d
	jsr Lbl_fda6

Lbl_936d:
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_9403
	jsr Lbl_9514
	jsr Lbl_db4e
	jsr Lbl_fbd7
	jsr Lbl_fa50
	jsr Lbl_dbdb
	jsr Lbl_fa00
	lda $058b		; Player 1-1 Energy
	sta $06b4
	ldx $058f		; number of human players?

Lbl_9394:
	lda $058b,x
	and $06b4
	sta $06b4
	dex 
	bpl Lbl_9394
	lda $06b4
	bpl Lbl_9350
	ldx $058f		; number of human players?

Lbl_93a8:
	lda $0587,x		; bean ball #players??
	and #$0f
	sta $06b4
	lda $0587,x		; bean ball #players??
	and #$f0
	lsr a
	lsr a
	lsr a
	clc 
	adc $06b4
	sta a:$0086,x
	dex 
	bpl Lbl_93a8
	ldx #$03

Lbl_93c4:
	cpx $058f		; number of human players?
	beq Lbl_93d1	; branch if equal
	lda #$ff
	sta a:$0086,x
	dex 
	bpl Lbl_93c4

Lbl_93d1:
	lda #$00
	jsr sub_PlaySound	; play a song/sound effect
	rts 

Lbl_93d7:
	.byte $25,$2b,$65,$2b,$a5,$2b,$e5,$2b

Lbl_93df:
	ldx #$03

Lbl_93e1:
	lda Lbl_93ff,x
	sta $0587,x		; bean ball #players??
	dex 
	bpl Lbl_93e1
	lda #$00
	sta $058b		; Player 1-1 Energy
	sta $058c
	sta $058d
	sta $058e
	ldx $6f			; number of human players
	dex				; subtract one
	stx $058f		; store new number of human players
	rts 

Lbl_93ff:
	.byte $00,$01,$10,$11

Lbl_9403:
	lda $069e
	and #$03
	cmp a:$006f		; number of human players
	bcc Lbl_940e	; branch if carry clear
	rts 

Lbl_940e:
	tax
	cpx #$00
	bne Lbl_9428
	lda $f5			; player 1 trigger input
	and #$30		; start/select?
	beq Lbl_9428
	lda #$80
	sta $058b		; Player 1-1 Energy
	sta $058c
	sta $058d
	sta $058e
	rts 

Lbl_9428:
	lda $f5,x		; P1/P2 trigger input
	and #$cf		; everything but start/select
	bne Lbl_9431
	jmp Lbl_950f

Lbl_9431:
	pha 
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	pla 
	tay 
	and #$80
	beq Lbl_944e
	lda $058b,x
	ora #$80
	sta $058b,x
	lda Lbl_9510,x
	jsr Lbl_9537
	jmp Lbl_950f

Lbl_944e:
	tya 
	and #$40
	beq Lbl_9463
	lda $058b,x
	and #$7f
	sta $058b,x
	lda #$00
	jsr Lbl_9537
	jmp Lbl_950f

Lbl_9463:
	lda $058b,x
	bpl Lbl_946b
	jmp Lbl_950f

Lbl_946b:
	tya 
	and #$08
	beq Lbl_949a
	lda #$00
	jsr Lbl_9537
	lda $0587,x		; bean ball #players??
	sta $0591
	sta $0592		; Player 1-1 Movement Dir.
	jsr Lbl_956d
	jsr Lbl_95ce
	bcc Lbl_9494
	jsr Lbl_956d
	jsr Lbl_95ce
	bcc Lbl_9494
	jsr Lbl_95dd
	jmp Lbl_950f

Lbl_9494:
	jsr Lbl_95e4
	jmp Lbl_950f

Lbl_949a:
	tya 
	and #$04
	beq Lbl_94c9
	lda #$00
	jsr Lbl_9537
	lda $0587,x		; bean ball #players??
	sta $0591
	sta $0592		; Player 1-1 Movement Dir.
	jsr Lbl_9590
	jsr Lbl_95ce
	bcc Lbl_94c3
	jsr Lbl_9590
	jsr Lbl_95ce
	bcc Lbl_94c3
	jsr Lbl_95dd
	jmp Lbl_950f

Lbl_94c3:
	jsr Lbl_95e4
	jmp Lbl_950f

Lbl_94c9:
	tya 
	and #$02
	beq Lbl_94f0
	lda #$00
	jsr Lbl_9537
	lda $0587,x		; bean ball #players??
	sta $0591
	sta $0592		; Player 1-1 Movement Dir.
	jsr Lbl_95a4
	jsr Lbl_95ce
	bcc Lbl_94ea
	jsr Lbl_95dd
	jmp Lbl_950f

Lbl_94ea:
	jsr Lbl_95e4
	jmp Lbl_950f

Lbl_94f0:
	lda #$00
	jsr Lbl_9537
	lda $0587,x		; bean ball #players??
	sta $0591
	sta $0592		; Player 1-1 Movement Dir.
	jsr Lbl_95be
	jsr Lbl_95ce
	bcc Lbl_950c
	jsr Lbl_95dd
	jmp Lbl_950f

Lbl_950c:
	jsr Lbl_95e4

Lbl_950f:
	rts 

Lbl_9510:
	.byte $7d,$7e,$51,$43

Lbl_9514:
	lda $069e
	and #$03
	cmp a:$006f		; number of human players
	bcc Lbl_951f	; branch if carry clear
	rts 

Lbl_951f:
	tax
	ldy #$00
	lda $069e
	and #$08
	beq Lbl_952d
	lda Lbl_9510,x
	tay 

Lbl_952d:
	lda $058b,x
	bmi Lbl_9536
	tya 
	jsr Lbl_9537

Lbl_9536:
	rts 

Lbl_9537:
	pha 
	lda $0587,x		; bean ball #players??
	and #$0f
	sta $06b4
	lda $0587,x		; bean ball #players??
	and #$f0
	lsr a
	lsr a
	lsr a
	clc 
	adc $06b4
	asl a 
	tay 
	lda Lbl_9561,y
	pha 
	lda Lbl_9562,y
	sta $2006		; PPUADDR
	pla 
	sta $2006		; PPUADDR
	pla 
	sta $2007		; PPUDATA
	rts 

; more nametable locations
Lbl_9561:
	.byte $65

Lbl_9562:
	.byte $29,$72,$29,$25,$2a,$32,$2a,$e5,$2a,$f2,$2a
; end nametable locations

Lbl_956d:
	lda $0592		; Player 1-1 Movement Dir.?
	and #$f0
	lsr a
	lsr a
	lsr a
	lsr a
	tay 
	dey 
	bpl Lbl_957c
	ldy #$02

Lbl_957c:
	tya 
	asl a 
	asl a 
	asl a 
	asl a 
	sta $06b4
	lda $0591
	and #$0f
	ora $06b4
	sta $0592		; Player 1-1 Movement Dir.
	rts 

Lbl_9590:
	lda $0592		; Player 1-1 Movement Dir.
	and #$f0
	lsr a
	lsr a
	lsr a
	lsr a
	tay 
	iny 
	cpy #$03
	bcc Lbl_95a1
	ldy #$00

Lbl_95a1:
	jmp Lbl_957c

Lbl_95a4:
	lda $0592		; Player 1-1 Movement Dir.
	and #$0f
	tay 
	dey 
	bpl Lbl_95af
	ldy #$01

Lbl_95af:
	sty $06b4
	lda $0591
	and #$f0
	ora $06b4
	sta $0592		; Player 1-1 Movement Dir.
	rts 

Lbl_95be:
	lda $0592		; Player 1-1 Movement Dir.
	and #$0f
	tay 
	iny 
	cpy #$02
	bcc Lbl_95cb
	ldy #$00

Lbl_95cb:
	jmp Lbl_95af

Lbl_95ce:
	ldy $058f		; number of human players?

Lbl_95d1:
	cmp $0587,y		; bean ball #players??
	beq Lbl_95db
	dey
	bpl Lbl_95d1
	clc				; clear carry
	rts

Lbl_95db:
	sec				; set carry
	rts

Lbl_95dd:
	lda $0591
	sta $0587,x		; bean ball #players??
	rts 

Lbl_95e4:
	lda $0592		; Player 1-1 Movement Dir.
	sta $0587,x		; bean ball #players??
	rts 

Lbl_95eb:
	lda $06ea		; difficulty level
	asl a 
	tay 
	lda Lbl_9611,y	; use shifted difficulty level as index into Lbl_9611
	sta $61
	lda Lbl_9612,y	; use shifted difficulty level as index into Lbl_9612
	sta $62
	lda #$2b
	sta $2006		; PPUADDR
	lda #$52
	sta $2006		; PPUADDR = $2b52
	ldy #$00

Lbl_9606:
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	cpy #$09
	bcc Lbl_9606	; branch if carry clear
	rts 

Lbl_9611:		; based on (shifted) difficulty level
	.byte $17

Lbl_9612:		; based on (shifted) difficulty level
	.byte $96,$20,$96,$29,$96,$00,$00,$a4,$a0,$b2,$b8,$00,$00,$00,$00,$ad
	.byte $ae,$b1,$ac,$a0,$ab,$00,$00,$a3,$a8,$a5,$a5,$a8,$a2,$b4,$ab,$b3

Lbl_9632:
	lda #$00
	sta $06b4
	lda $06ed
	and #$bf		; mask: b10111111
	beq Lbl_9665	; branch if equal
	sta $06b5
	lda #$05
	sta $06b6		; set $06b6 = #$05

Lbl_9646:
	lsr $06b5
	bcc Lbl_964e
	jsr Lbl_9666

Lbl_964e:
	inc $06b4
	lda $06b4
	cmp #$06
	bcc Lbl_9646
	bit $06ed
	bpl Lbl_9665	; branch if positive
	lda #$08
	sta $06b6
	jsr Lbl_9666

Lbl_9665:
	rts 

Lbl_9666:
	lda $06b4
	asl a 
	tax
	lda Lbl_968f,x
	sta $61
	lda Lbl_9690,x
	sta $62
	lda Lbl_969e,x
	sta $2006		; PPUADDR
	lda Lbl_969d,x
	sta $2006		; PPUADDR
	ldy #$00

Lbl_9683:
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	cpy $06b6
	bcc Lbl_9683
	rts 

Lbl_968f:
	.byte $cf

Lbl_9690:
	.byte $05,$d4,$05,$d9,$05,$de,$05,$e3,$05,$e8,$05,$bf,$05

Lbl_969d:
	.byte $67

Lbl_969e:
	.byte $29,$74,$29,$27,$2a,$34,$2a,$e7,$2a,$f4,$2a,$ec,$28

Lbl_96ab:
	lda $70
	and #$60		; mask #$60
	beq Lbl_96b2	; branch if equal
	rts 

Lbl_96b2:
	lda #$1f
	jsr sub_PlaySound	; play song #$1f (next match screen)
	jsr Lbl_fe8a
	jsr Lbl_fcb5
	jsr Lbl_db2e
	jsr Lbl_dbf1
	jsr sub_UpdateOAM	; update OAM
	lda #$13
	jsr Lbl_fa65
	jsr Lbl_9883
	jsr Lbl_98f9
	jsr Lbl_97b4
	jsr Lbl_fca0
	jsr Lbl_97d1
	jsr Lbl_983f
	jsr Lbl_95eb
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr Lbl_9765
	jsr Lbl_db4e
	jsr Lbl_fcbf
	lda #$00
	sta $031f
	sta $0357
	sta $038f
	sta $03c7
	sta $03ff
	sta $0437

Lbl_9703:
	lda #$04
	sta $0617
	lda #$00
	sta $067a
	sta $067b

Lbl_9710:
	inc $069e
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda $069e
	and #$01
	bne Lbl_972c
	jsr Lbl_fbe8
	jmp Lbl_9710

Lbl_972c:
	jsr Lbl_fa50
	jsr Lbl_dbdb
	jsr Lbl_fd5d
	lda $f5			; player 1 trigger input
	tay
	and #$c0		; A/B
	bne Lbl_975f
	tya 
	and #$20		; select
	beq Lbl_9758
	lda #$29
	jsr sub_PlaySound	; play song #$29 (bean ball)
	jsr Lbl_dbf1
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_998c
	jmp Lbl_96b2

Lbl_9758:
	lda $0700
	and #$02
	bne Lbl_9703

Lbl_975f:
	lda #$00
	jsr sub_PlaySound	; play a song/sound effect
	rts 

Lbl_9765:
	lda #$00
	ldx $71			; current stage
	beq Lbl_976d
	lda #$01

Lbl_976d:
	pha 
	tax
	lda Lbl_97a6,x
	sta $069c		; set Normal match Character Color
	lda Lbl_97a8,x
	sta $06eb		; ball color
	lda #$ff
	sta $069d		; (player color dupe?)
	sta $06ec
	txa
	asl a 
	eor #$02
	ora $70
	sta $70
	jsr Lbl_df58
	lda $70
	and #$fd		; mask #$fd
	sta $70
	pla 
	tax
	lda Lbl_97aa,x
	sta $06ae		; set current Left/Sprite CHR bank
	sta $06af		; set (current Left/Sprite CHR bank dupe?)
	lda $06ae		; load current Left/Sprite CHR bank
	jsr MMC1_SetCHRBank0		; set chr bank 0 based on value at $06ae
	rts 

Lbl_97a6:
	.byte $00,$bb

Lbl_97a8:		; ball color array?
	.byte $00,$0b

Lbl_97aa:
	.byte $0d,$0c,$ad,$00,$07,$29,$02,$d0,$f9,$60

Lbl_97b4:
	lda $06ed
	bpl Lbl_97d0	; branch if positive
	lda #$29
	sta $2006		; PPUADDR
	lda #$0c
	sta $2006		; PPUADDR = $290C
	ldy #$00

Lbl_97c5:
	lda $05bf,y
	sta $2007		; PPUDATA
	iny 
	cpy #$08
	bcc Lbl_97c5	; branch if carry clear

Lbl_97d0:
	rts 

Lbl_97d1:
	lda #$27
	sta $02
	sta $08
	lda #$98
	sta $03
	sta $09
	lda a:$007a		; P2 Team
	asl a 
	tax
	lda Lbl_9805,x
	sta $61
	lda Lbl_9806,x
	sta $62
	ldy #$00
	lda ($61),y
	sta $04
	iny 
	lda ($61),y
	sta $05
	iny 
	lda ($61),y
	sta $06
	iny 
	lda ($61),y
	sta $07
	jsr Lbl_a67b
	rts 

Lbl_9805:
	.byte $17

Lbl_9806:
	.byte $98,$17,$98,$17,$98,$1b,$98,$17,$98,$23,$98,$17,$98,$1f,$98,$23
	.byte $98,$2b,$98,$2b,$98,$2f,$98,$33,$98,$3b,$98,$33,$98,$37,$98,$37
	.byte $98
	; Flag palettes
	.byte $0c,$30,$00,$17		; [white/gray/brown]
	.byte $0c,$30,$1c,$16		; USA, England, Iceland
	.byte $0c,$30,$27,$12		; India top
	.byte $0c,$30,$16,$2a		; India bottom, Kenya Top
	.byte $0c,$30,$37,$16		; China, Japan, USSR
	.byte $0c,$30,$16,$0f		; Kenya Top

Lbl_983f:
	lda a:$007a		; P2 Team
	asl a 
	tax
	lda Lbl_9c0d,x
	sta $63
	lda Lbl_9c0e,x		; flags
	sta $64
	lda #$21
	ldy #$af
	sta $2006		; PPUADDR
	sty $2006		; PPUADDR
	ldy #$00
	ldx #$03

Lbl_985c:
	lda ($63),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_985c
	lda #$21
	ldy #$cf
	sta $2006		; PPUADDR
	sty $2006		; PPUADDR
	ldy #$03
	ldx #$03

Lbl_9873:
	lda ($63),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_9873
	rts 

Lbl_987d:
	.byte $17,$18,$0b,$19,$1a,$1b

Lbl_9883:
	lda $71			; current stage
	and #$07		; stage & 0x07 (since there's only 8 teams)
	tax
	lda Lbl_98f0,x	; get stage number tile
	pha 
	cpx #$06
	bcc Lbl_98e1
	pla 
	txa
	and #$01
	asl a 
	tax
	lda Lbl_98b7,x
	sta $61
	lda Lbl_98b8,x
	sta $62
	lda #$29
	sta $2006		; PPUADDR
	lda #$27
	sta $2006		; PPUADDR
	ldy #$00

Lbl_98ac:
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	cpy #$13
	bcc Lbl_98ac
	rts 

Lbl_98b7:
	.byte $bb

Lbl_98b8:
	; "semifinal" and "final" live here
	.byte $98,$ce,$98,$00,$00,$00,$00,$b2,$a4,$ac,$a8,$a5,$a8,$ad,$a0,$ab
	.byte $b2,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$a5,$a8,$ad,$a0
	.byte $ab,$00,$00,$00,$00,$00,$00,$00,$00

Lbl_98e1:
	lda #$29
	sta $2006		; PPUADDR
	lda #$39
	sta $2006		; PPUADDR
	pla 
	sta $2007		; PPUDATA
	rts 

Lbl_98f0:	; stage numbers 1-9
	.byte $bb,$bc,$bd,$be,$bf,$c0,$c1,$c2,$c3

Lbl_98f9:
	lda a:$007a		; P2 Team
	asl a 
	tay 
	lda Lbl_9ba6,y
	sta $61
	lda Lbl_9ba7,y		; team names
	sta $62
	lda #$29
	sta $2006		; PPUADDR
	lda #$6c
	sta $2006		; PPUADDR
	ldy #$00

Lbl_9914:
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	cpy #$09
	bcc Lbl_9914
	rts 

Lbl_991f:
	.byte $31

Lbl_9920:
	.byte $99,$3a,$99,$43,$99,$4c,$99,$55,$99,$5e,$99,$67,$99,$70,$99,$79
	.byte $99
	; team names
	.byte $b3,$a4,$a0,$ac,$00,$b4,$b2,$a0,$00		; Team USA
	.byte $a0,$ab,$ab,$00,$b2,$b3,$a0,$b1,$b2		; All Stars
	.byte $a4,$ad,$a6,$ab,$a0,$ad,$a3,$00,$00		; England
	.byte $a8,$ad,$a3,$a8,$a0,$00,$00,$00,$00		; India
	.byte $a8,$a2,$a4,$ab,$a0,$ad,$a3,$00,$00		; Iceland
	.byte $a2,$a7,$a8,$ad,$a0,$00,$00,$00,$00		; China
	.byte $b4,$b2,$b2,$b1,$00,$00,$00,$00,$00		; USSR
	.byte $aa,$a4,$ad,$b8,$a0,$00,$00,$00,$00		; Kenya
	.byte $a9,$a0,$af,$a0,$ad,$00,$00,$00,$00		; Japan

Lbl_9982:
	ldx #$07
	lda #$ff

Lbl_9986:
	sta $f1,x
	dex 
	bpl Lbl_9986
	rts 

Lbl_998c:
	lda #$00
	jsr Lbl_af32

Lbl_9991:
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_fd5d
	lda $f5			; player 1 trigger input
	and #$a0		; B or select
	beq Lbl_9991
	lda a:$007a		; P2 Team
	ora #$80
	jsr Lbl_af32

Lbl_99ae:
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_fd5d
	lda $f5			; player 1 trigger input
	tay
	and #$a0
	bne Lbl_99cb
	tya
	and #$40		; B button?
	bne Lbl_998c	; branch if not equal
	beq Lbl_99ae	; branch if equal

Lbl_99cb:
	rts 

Lbl_99cc:
	jsr Lbl_dbf1
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda $7b			; P1 Team
	and #$7f
	jsr Lbl_af32

Lbl_99df:
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_fd5d
	jsr Lbl_fa00
	lda $f5			; player 1 trigger input
	and #$a0
	beq Lbl_99df
	lda $7a			; P2 Team
	ora #$80
	jsr Lbl_af32

Lbl_99fb:
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	jsr Lbl_fd5d
	jsr Lbl_fa00
	lda $f5			; player 1 trigger input
	tay
	and #$a0
	bne Lbl_9a18
	tya 
	and #$40		; b button
	bne Lbl_99cc	; branch if not equal
	beq Lbl_99fb	; branch if equal

Lbl_9a18:
	rts 

Lbl_9a19:
	.byte $00,$00,$00,$00,$00,$00,$00

Lbl_9a20:
	bit $70
	bvc Lbl_9a25	; branch if overflow clear
	rts 

Lbl_9a25:
	jsr Lbl_fe8a
	jsr Lbl_fcb5
	jsr Lbl_db2e
	jsr Lbl_dbf1
	lda #$0e
	jsr Lbl_fa65
	jsr Lbl_fca0
	lda $06ed
	ldx #$01
	jsr Lbl_9b0c
	jsr Lbl_fca0
	lda $06ed
	ldx #$01
	jsr Lbl_9c57
	jsr Lbl_fca0
	lda $70
	and #$20		; mask #$20 (versus mode?)
	bne Lbl_9a59	; branch if not equal
	lda #$00
	beq Lbl_9a5c

Lbl_9a59:
	lda $06ee		; load $06ee

Lbl_9a5c:
	ldx #$00
	pha 
	jsr Lbl_9b0c
	jsr Lbl_fca0
	pla 
	ldx #$00
	jsr Lbl_9c57
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr Lbl_db4e
	jsr Lbl_fcbf
	lda #$29
	jsr sub_PlaySound	; play song #$29 (bean ball)

Lbl_9a7c:
	jsr Lbl_9e14
	jsr Lbl_9ec1

Lbl_9a82:
	lda #$00
	sta $0617
	lda $67
	and #$01
	bne Lbl_9a97
	jsr Lbl_9ece
	lda $67
	bpl Lbl_9af1
	jmp Lbl_9ad0

Lbl_9a97:
	jsr Lbl_9f1e
	lda $67
	bpl Lbl_9ae3
	lda $68
	bpl Lbl_9ae3
	ldx #$00
	ldy #$06

Lbl_9aa6:
	lda $4d,x
	sta $060b,x
	inx 
	dey 
	bne Lbl_9aa6
	lda $06ed		; load $06ed
	ora #$40		; OR $06ed by #$40
	sta $06ed		; store new $06ed
	lda $70
	and #$20		; mask #$20
	beq Lbl_9ad0	; branch if equal
	ldy #$06

Lbl_9abf:
	lda $4d,x
	sta $060b,x
	inx 
	dey 
	bne Lbl_9abf
	lda $06ee		; load $06ee
	ora #$40
	sta $06ee		; set $06ee

Lbl_9ad0:
	ldx #$0b

Lbl_9ad2:
	lda $4d,x
	sta $06f0,x
	dex 
	bpl Lbl_9ad2	; branch if positive
	jsr Lbl_a484
	lda #$00
	jsr sub_PlaySound	; play a song/sound effect
	rts 

Lbl_9ae3:
	bit $67
	bvc Lbl_9af1
	lda $70
	and #$20		; mask #$20
	beq Lbl_9a7c
	bit $68
	bvs Lbl_9a7c

Lbl_9af1:
	jsr Lbl_a2c8
	jsr Lbl_a360
	jsr Lbl_dbdb
	jsr Lbl_fa00
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	inc $069e
	jmp Lbl_9a82

Lbl_9b0c:
	sta $4d
	stx $4e
	lda $4d
	bmi Lbl_9b2f
	lda $7a,x		; p2 or p1 team, depending on X
	asl a 
	tax
	lda Lbl_9ba6,x
	sta $61
	lda Lbl_9ba7,x		; team names
	sta $62
	lda Lbl_9c0d,x
	sta $63
	lda Lbl_9c0e,x		; flags
	sta $64
	jmp Lbl_9b48

Lbl_9b2f:
	lda #$bf
	sta $61
	lda #$05
	sta $62
	lda $4e
	bne Lbl_9b48
	clc 
	lda $61
	adc #$08
	sta $61
	lda $62
	adc #$00
	sta $62

Lbl_9b48:
	lda $4e
	asl a 
	tax
	lda Lbl_9c09,x
	tay 
	lda Lbl_9c0a,x
	sta $2006		; PPUADDR
	sty $2006		; PPUADDR
	ldy #$00
	ldx #$09

Lbl_9b5d:
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_9b5d
	lda $4e
	asl a 
	tax
	lda Lbl_9c4f,x
	tay 
	lda Lbl_9c50,x
	sta $2006		; PPUADDR
	sty $2006		; PPUADDR
	ldy #$00
	ldx #$03

Lbl_9b7b:
	lda ($63),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_9b7b
	lda $4e
	asl a 
	tax
	lda Lbl_9c53,x
	tay 
	lda Lbl_9c54,x
	sta $2006		; PPUADDR
	sty $2006		; PPUADDR
	ldy #$03
	ldx #$03

Lbl_9b99:
	lda ($63),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_9b99
	jsr Lbl_a54c
	rts 

Lbl_9ba6:
	.byte $b8

Lbl_9ba7:
	.byte $9b,$c1,$9b,$ca,$9b,$d3,$9b,$dc,$9b,$e5,$9b,$ee,$9b,$f7,$9b,$00
	.byte $9c
	; Team Names ('A'=0xA0)
	.byte $b3,$a4,$a0,$ac,$00,$b4,$b2,$a0,$00			; Team USA
	.byte $a0,$ab,$ab,$fc,$b2,$b3,$a0,$b1,$b2,$00		; All-Stars
	.byte $a4,$ad,$a6,$ab,$a0,$ad,$a3,$00,$00,$00		; England
	.byte $a8,$ad,$a3,$a8,$a0,$00,$00,$00				; India
	.byte $a8,$a2,$a4,$ab,$a0,$ad,$a3,$00,$00,$00		; Iceland
	.byte $a2,$a7,$a8,$ad,$a0,$00,$00,$00,$00			; China
	.byte $a9,$a0,$af,$a0,$ad,$00,$00,$00,$00			; Japan
	.byte $aa,$a4,$ad,$b8,$a0,$00,$00,$00,$00			; Kenya
	.byte $b4,$b2,$b2,$b1,$00,$00,$00					; USSR

Lbl_9c09:
	.byte $36

Lbl_9c0a:
	.byte $21,$26,$21

Lbl_9c0d:
	.byte $1f

Lbl_9c0e:
	.byte $9c,$1f,$9c,$25,$9c,$2b,$9c,$31,$9c,$37,$9c,$3d,$9c,$43,$9c,$49
	.byte $9c
	; Flags
	.byte $79,$7a,$7b,$89,$8a,$8b		; USA
	.byte $70,$71,$72,$80,$81,$82		; England
	.byte $0c,$0d,$0e,$1c,$1d,$1e		; India
	.byte $73,$74,$75,$83,$84,$85		; Iceland
	.byte $09,$0a,$0b,$19,$1a,$1b		; China
	.byte $76,$77,$78,$86,$87,$88		; Japan
	.byte $90,$91,$92,$93,$94,$95		; Kenya
	.byte $17,$18,$0b,$19,$1a,$1b		; USSR

Lbl_9c4f:
	.byte $32

Lbl_9c50:
	.byte $21,$22,$21

Lbl_9c53:
	.byte $52

Lbl_9c54:
	.byte $21,$42,$21

Lbl_9c57:
	sta $4d
	stx $4e
	lda #$01
	sta $4f
	lda #$06
	sta $50
	lda #$00
	sta $51

Lbl_9c67:
	lda $4d
	and $4f
	bne Lbl_9c80
	ldx $4e
	lda $7a,x		; p2 or p1 team, depending on X
	asl a 
	tax
	lda Lbl_9cf0,x		; player name table-ish
	sta $61
	lda Lbl_9cf1,x		; player name table
	sta $62
	jmp Lbl_9c99

Lbl_9c80:
	lda #$cf
	sta $61
	lda #$05
	sta $62
	lda $4e
	bne Lbl_9c99
	clc 
	lda $61
	adc #$1e
	sta $61
	lda $62
	adc #$00
	sta $62

Lbl_9c99:
	ldy $51
	beq Lbl_9cad

Lbl_9c9d:
	clc 
	lda $61
	adc #$05
	sta $61
	lda $62
	adc #$00
	sta $62
	dey 
	bne Lbl_9c9d

Lbl_9cad:
	lda $4e
	asl a 
	tax
	lda Lbl_9e10,x
	sta $63
	lda Lbl_9e11,x
	sta $64
	ldy $51
	beq Lbl_9ccf

Lbl_9cbf:
	clc 
	lda $63
	adc #$20
	sta $63
	lda $64
	adc #$00
	sta $64
	dey 
	bne Lbl_9cbf

Lbl_9ccf:
	ldy $63
	sta $2006		; PPUADDR
	sty $2006		; PPUADDR
	ldy #$00
	ldx #$05

Lbl_9cdb:
	lda ($61),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_9cdb
	asl $4f
	inc $51
	dec $50
	beq Lbl_9cef
	jmp Lbl_9c67

Lbl_9cef:
	rts 

Lbl_9cf0:
	.byte $02

Lbl_9cf1:
	.byte $9d,$20,$9d,$3e,$9d,$5c,$9d,$7a,$9d,$98,$9d,$b6,$9d,$d4,$9d,$f2
	.byte $9d
	; Player Names, where 'A' = 0xB2
	;-- team usa --;
	.byte $b2,$a0,$ac,$00,$00		; Sam
	.byte $a9,$ae,$a7,$ad,$00		; John
	.byte $ac,$a8,$aa,$a4,$00		; Mike
	.byte $b1,$a0,$ad,$a3,$b8		; Randy
	.byte $a1,$a8,$ab,$ab,$00		; Bill
	.byte $b2,$b3,$a4,$b5,$a4		; Steve
	;-- pro all-stars --;
	.byte $a9,$a0,$a2,$aa,$00		; Jack
	.byte $b3,$ae,$ac,$00,$00		; Tom
	.byte $a5,$b1,$a4,$a3,$00		; Fred
	.byte $a1,$a4,$ad,$00,$00		; Ben
	.byte $af,$a0,$b4,$ab,$00		; Paul
	.byte $a3,$a0,$b5,$a8,$a3		; David
	;-- england --;
	.byte $a9,$a0,$ac,$a4,$b2		; James
	.byte $b2,$a2,$ae,$b3,$b3		; Scott
	.byte $a7,$a4,$ad,$b1,$b8		; Henry
	.byte $b1,$ae,$a6,$a4,$b1		; Roger
	.byte $af,$a4,$b3,$a4,$b1		; Peter
	.byte $a2,$ab,$a8,$a5,$a5		; Cliff
	;-- india --;
	.byte $b1,$a0,$a9,$a8,$b5		; Rajiv
	.byte $b2,$b6,$a0,$ac,$a8		; Swami
	.byte $a1,$a0,$b3,$a0,$00		; Bata
	.byte $aa,$b4,$ac,$a0,$b1		; Kumar
	.byte $b9,$a0,$a8,$ab,$00		; Zail
	.byte $a0,$aa,$a1,$a0,$b1		; Akbar
	;-- iceland --;
	.byte $a7,$a4,$ab,$a6,$a8		; Helgi
	.byte $aa,$ad,$b4,$b3,$00		; Knut
	.byte $a7,$a0,$ad,$b2,$00		; Hans
	.byte $a1,$a9,$ae,$b1,$ad		; Bjorn
	.byte $ad,$a8,$ab,$b2,$00		; Nils
	.byte $a6,$a8,$b2,$ab,$a8		; Gisli
	;-- china --;
	.byte $b6,$a0,$ad,$a6,$00		; Wang
	.byte $a7,$b2,$a8,$a4,$a7		; Hsieh
	.byte $ab,$a8,$00,$00,$00		; Li
	.byte $a2,$a7,$ae,$b4,$00		; Chou
	.byte $ac,$a0,$ae,$00,$00		; Mao
	.byte $b3,$b2,$a0,$a8,$00		; Tsai
	;-- japan --;
	.byte $a5,$b4,$a9,$a8,$00		; Fuji
	.byte $b2,$a0,$b3,$ae,$00		; Sato
	.byte $a7,$ae,$ad,$a3,$a0		; Honda
	.byte $a0,$ae,$aa,$a8,$00		; Aoki
	.byte $ae,$a3,$a0,$00,$00		; Oda
	.byte $a7,$a8,$ad,$ae,$00		; Hino
	;-- kenya --;
	.byte $b8,$a4,$ac,$a8,$00		; Yemi
	.byte $ae,$a1,$a0,$00,$00		; Oba
	.byte $b3,$a0,$a7,$a0,$00		; Taha
	.byte $a4,$b8,$ae,$00,$00		; Eyo
	.byte $a1,$b6,$ae,$a6,$a8		; Bwogi
	.byte $ac,$b6,$a0,$a8,$00		; Mwai
	;-- USSR --;
	.byte $a1,$ae,$b1,$a8,$b2		; Boris
	.byte $a8,$b5,$a0,$ad,$00		; Ivan
	.byte $af,$a0,$b5,$a4,$ab		; Pavel
	.byte $a8,$a6,$ae,$b1,$00		; Igor
	.byte $b5,$ae,$ab,$a5,$00		; Volf
	.byte $b8,$a0,$aa,$ae,$b5		; Yakov

Lbl_9e10:
	.byte $d2

Lbl_9e11:
	.byte $21,$c2,$21

Lbl_9e14:
	lda #$01
	sta $59
	lda #$4d
	sta $63
	lda #$00
	sta $64

Lbl_9e20:
	lda $59
	bne Lbl_9e2c
	lda $70
	and #$60		; mask #$60
	beq Lbl_9e36	; branch if equal
	lda $59

Lbl_9e2c:
	eor #$01
	tax
	lda $06ed,x
	and #$40
	bne Lbl_9e49

Lbl_9e36:
	ldx $59
	lda $7a,x		; p2 or p1 team, depending on X
	asl a 
	tax
	lda Lbl_9e75,x
	sta $61
	lda Lbl_9e76,x
	sta $62
	jmp Lbl_9e57

Lbl_9e49:
	lda $59
	asl a 
	tax
	lda Lbl_9ebd,x
	sta $61
	lda Lbl_9ebe,x
	sta $62

Lbl_9e57:
	ldy #$00
	ldx #$06

Lbl_9e5b:
	lda ($61),y
	sta ($63),y
	iny 
	dex 
	bne Lbl_9e5b
	clc 
	lda $63
	adc #$06
	sta $63
	lda $64
	adc #$00
	sta $64
	dec $59
	bpl Lbl_9e20
	rts 

Lbl_9e75:
	.byte $87

Lbl_9e76:
	.byte $9e,$8d,$9e,$93,$9e,$99,$9e,$9f,$9e,$a5,$9e,$ab,$9e,$b1,$9e,$b7
	.byte $9e
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06
	.byte $01,$02,$03,$04,$05,$06

Lbl_9ebd:
	.byte $11

Lbl_9ebe:
	.byte $06,$0b,$06

Lbl_9ec1:
	lda #$30
	sta $61
	lda #$70
	sta $63
	lda #$00
	sta $67
	rts 

Lbl_9ece:
	jsr Lbl_fd5d
	lda $f5			; player 1 trigger input
	ora $f6			; player 2 trigger input
	sta $59
	and #$90
	bne Lbl_9eed
	lda $59
	and #$0c
	beq Lbl_9eec
	lda #$18
	eor $61
	sta $61
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)

Lbl_9eec:
	rts 

Lbl_9eed:
	lda #$28
	cmp $61
	beq Lbl_9efa
	lda $67
	ora #$80
	sta $67
	rts 

Lbl_9efa:
	ldx #$0b
	lda #$00

Lbl_9efe:
	sta $4d,x
	dex 
	bpl Lbl_9efe
	lda #$70
	sta $61
	sta $62
	lda #$08
	sta $63
	lda #$88
	sta $64
	lda #$01
	sta $65
	sta $66
	sta $67
	lda #$00
	sta $68
	rts 

Lbl_9f1e:
	jsr Lbl_fd5d
	lda $f5			; player 1 trigger input
	and #$0c
	beq Lbl_9f2f
	ldx #$00
	jsr Lbl_a1ee
	jmp Lbl_9f46

Lbl_9f2f:
	lda $f5			; player 1 trigger input
	and #$c0		; up/down
	beq Lbl_9f46	; branch if equal
	and #$80		; A button
	beq Lbl_9f41	; branch if equal
	ldx #$00
	jsr Lbl_a212
	jmp Lbl_9f46

Lbl_9f41:
	ldx #$00
	jsr Lbl_a289

Lbl_9f46:
	lda $70
	and #$20		; checking for versus mode
	bne Lbl_9f4f	; branch if not equal
	jsr Lbl_9f75

Lbl_9f4f:
	lda $f6			; player 2 trigger input
	and #$0c		; up/down
	beq Lbl_9f5d
	ldx #$01
	jsr Lbl_a1ee
	jmp Lbl_9f74

Lbl_9f5d:
	lda $f6			; player 2 trigger input
	and #$c0		; up/down
	beq Lbl_9f74
	and #$80		; A button
	beq Lbl_9f6f
	ldx #$01
	jsr Lbl_a212
	jmp Lbl_9f74

Lbl_9f6f:
	ldx #$01
	jsr Lbl_a289

Lbl_9f74:
	rts 

Lbl_9f75:
	lda $68
	and #$20
	bne Lbl_9fc0
	lda #$10
	sta $5c
	jsr Lbl_db89
	and #$1f
	pha 
	lda $7a			; P2 Team
	asl a 
	asl a 
	tax
	ldy #$04
	pla 

Lbl_9f8d:
	cmp Lbl_9fe2,x
	bcc Lbl_9f96
	inx 
	dey 
	bne Lbl_9f8d

Lbl_9f96:
	sty $59
	lda #$04
	sec 
	sbc $59
	sta $59
	lda $7a			; P2 Team
	asl a 
	tax
	lda Lbl_a006,x
	sta $5a
	lda Lbl_a007,x
	sta $5b
	lda $59
	asl a 
	tay 
	lda ($5a),y
	sta $5d
	iny 
	lda ($5a),y
	sta $5e
	lda $68
	ora #$20
	sta $68

Lbl_9fc0:
	lda #$00
	dec $5c
	bne Lbl_9fdf
	lda #$10
	sta $5c
	ldy #$00
	lda ($5d),y
	beq Lbl_9fdf
	pha 
	lda $5d
	clc 
	adc #$01
	sta $5d
	lda $5e
	adc #$00
	sta $5e
	pla 

Lbl_9fdf:
	sta $f6			; player 2 trigger input
	rts 

Lbl_9fe2:
	.byte $0e,$12,$20,$00,$0e,$12,$20,$00,$07,$0d,$14,$1a,$0a,$10,$14,$1e
	.byte $06,$0c,$13,$1c,$08,$10,$18,$20,$08,$10,$1a,$20,$01,$20,$00,$00
	.byte $0c,$18,$20,$00

Lbl_a006:
	.byte $18

Lbl_a007:
	.byte $a0,$22,$a0,$4b,$a0,$93,$a0,$d8,$a0,$1b,$a1,$5b,$a1,$98,$a1,$bb
	.byte $a1,$2c,$a0,$38,$a0,$43,$a0,$43,$a0,$43,$a0,$2c,$a0,$38,$a0,$43
	.byte $a0,$43,$a0,$43,$a0,$80,$80,$04,$04,$04,$80,$04,$80,$80,$80,$80
	.byte $00,$80,$04,$04,$80,$80,$80,$04,$80,$80,$80,$00,$80,$80,$80,$80
	.byte $80,$80,$80,$00,$55,$a0,$61,$a0,$70,$a0,$7f,$a0,$88,$a0,$80,$80
	.byte $04,$04,$04,$80,$04,$80,$80,$80,$80,$00,$80,$04,$04,$80,$08,$08
	.byte $80,$04,$04,$04,$80,$80,$80,$80,$00,$80,$80,$04,$04,$80,$08,$08
	.byte $80,$04,$04,$04,$80,$80,$80,$00,$80,$80,$80,$80,$04,$80,$80,$80
	.byte $00,$80,$80,$80,$04,$04,$80,$04,$80,$80,$80,$00,$9d,$a0,$a8,$a0
	.byte $b3,$a0,$c0,$a0,$c8,$a0,$80,$04,$80,$08,$08,$80,$80,$80,$80,$80
	.byte $00,$80,$80,$04,$80,$08,$08,$80,$80,$80,$80,$00,$80,$04,$04,$04
	.byte $80,$80,$04,$04,$80,$80,$80,$80,$00,$80,$80,$80,$80,$80,$80,$80
	.byte $00,$04,$04,$04,$80,$04,$04,$04,$80,$80,$04,$04,$80,$80,$80,$80
	.byte $00,$e2,$a0,$ec,$a0,$f8,$a0,$06,$a1,$13,$a1,$80,$80,$04,$04,$80
	.byte $80,$80,$80,$80,$00,$80,$04,$04,$80,$80,$04,$04,$80,$80,$80,$80
	.byte $00,$80,$08,$08,$80,$04,$80,$04,$80,$04,$04,$80,$80,$80,$00,$80
	.byte $04,$04,$80,$04,$80,$80,$04,$04,$80,$80,$80,$00,$80,$80,$80,$80
	.byte $80,$80,$80,$00,$25,$a1,$35,$a1,$41,$a1,$4d,$a1,$4d,$a1,$80,$04
	.byte $04,$80,$04,$04,$04,$80,$04,$04,$04,$80,$80,$80,$80,$00,$80,$08
	.byte $08,$80,$04,$04,$80,$80,$80,$80,$80,$00,$80,$04,$04,$04,$80,$80
	.byte $04,$80,$80,$80,$80,$00,$80,$04,$80,$04,$80,$04,$04,$80,$04,$04
	.byte $80,$80,$80,$00,$65,$a1,$72,$a1,$7e,$a1,$8a,$a1,$8a,$a1,$80,$80
	.byte $04,$04,$80,$04,$04,$04,$80,$80,$80,$80,$00,$80,$80,$04,$80,$04
	.byte $80,$04,$04,$80,$80,$80,$00,$80,$80,$04,$04,$04,$80,$80,$04,$80
	.byte $80,$80,$00,$80,$80,$04,$04,$04,$80,$04,$80,$08,$08,$80,$80,$80
	.byte $00,$a2,$a1,$b3,$a1,$b3,$a1,$b3,$a1,$b3,$a1,$08,$80,$08,$08,$80
	.byte $04,$04,$04,$80,$04,$04,$80,$04,$80,$80,$80,$00,$80,$80,$80,$80
	.byte $80,$80,$80,$00,$c5,$a1,$d4,$a1,$e6,$a1,$e6,$a1,$e6,$a1,$80,$04
	.byte $04,$80,$04,$80,$04,$80,$04,$04,$04,$80,$80,$80,$00,$80,$04,$04
	.byte $04,$80,$08,$08,$80,$04,$04,$04,$80,$04,$04,$80,$80,$80,$00,$80
	.byte $80,$80,$80,$80,$80,$80,$00

Lbl_a1ee:
	and #$04
	beq Lbl_a1ff
	lda #$08
	clc 
	adc $61,x
	cmp #$a0
	bne Lbl_a20a
	lda #$70
	bne Lbl_a20a

Lbl_a1ff:
	lda $61,x
	sec 
	sbc #$08
	cmp #$68
	bne Lbl_a20a
	lda #$98

Lbl_a20a:
	sta $61,x
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	rts 

Lbl_a212:
	stx $59
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	ldx $59
	lda $65,x
	bne Lbl_a22c
	lda #$01
	sta $65,x
	lda $67,x
	and #$bf
	sta $67,x
	jmp Lbl_a237

Lbl_a22c:
	cmp #$07
	bne Lbl_a237
	lda $67,x
	ora #$80
	sta $67,x
	rts 

Lbl_a237:
	jsr Lbl_a275
	tax
	lda $4d,x
	beq Lbl_a240
	rts 

Lbl_a240:
	ldx $59
	lda $65,x
	inc $65,x
	ldx $5b
	sta $4d,x
	cmp #$06
	bne Lbl_a24f
	rts 

Lbl_a24f:
	ldx $5b

Lbl_a251:
	inx 
	cpx #$06
	beq Lbl_a25a
	cpx #$0c
	bne Lbl_a260

Lbl_a25a:
	dex 
	dex 
	dex 
	dex 
	dex 
	dex 

Lbl_a260:
	lda $4d,x
	bne Lbl_a251

Lbl_a264:
	txa
	ldx $59
	beq Lbl_a26c
	sec 
	sbc #$06

Lbl_a26c:
	asl a 
	asl a 
	asl a 
	clc 
	adc #$70
	sta $61,x
	rts 

Lbl_a275:
	lda $61,x
	sec 
	sbc #$70
	lsr a
	lsr a
	lsr a
	sta $5a
	cpx #$00
	beq Lbl_a286
	clc 
	adc #$06

Lbl_a286:
	sta $5b
	rts 

Lbl_a289:
	stx $59
	lda #$10
	jsr sub_PlaySound	; play sound #$10 (cursor tick)
	ldx $59
	lda $65,x
	cmp #$01
	bne Lbl_a29f	; branch if not equal
	lda $67,x
	ora #$40
	sta $67,x
	rts 

Lbl_a29f:
	lda $67,x
	and #$7f
	sta $67,x
	dec $65,x
	jsr Lbl_a275
	ldx $59
	lda $65,x
	ldx $5b

Lbl_a2b0:
	dex 
	bmi Lbl_a2b7
	cpx #$05
	bne Lbl_a2bd

Lbl_a2b7:
	inx 
	inx 
	inx 
	inx 
	inx 
	inx 

Lbl_a2bd:
	cmp $4d,x
	bne Lbl_a2b0
	lda #$00
	sta $4d,x
	jmp Lbl_a264

Lbl_a2c8:
	lda #$0b
	sta $59

Lbl_a2cc:
	ldx $59
	lda Lbl_a354,x
	pha 
	lda $4d,x
	beq Lbl_a2e0
	sec 
	sbc #$03
	bpl Lbl_a2dd
	lda #$00

Lbl_a2dd:
	clc 
	adc #$bb

Lbl_a2e0:
	pha 
	lda Lbl_a348,x
	ldx $0617
	sta $0200,x
	pla 
	sta $0201,x
	lda #$00
	sta $0202,x
	pla 
	sta $0203,x
	lda $0617
	clc 
	adc #$04
	sta $0617
	dec $59
	bpl Lbl_a2cc
	lda #$00
	sta $59

Lbl_a308:
	ldx $59
	lda $63,x
	pha 
	lda $069e
	and #$10
	beq Lbl_a318
	lda #$3f
	bne Lbl_a31a

Lbl_a318:
	lda #$00

Lbl_a31a:
	pha 
	lda $61,x
	ldx $0617
	sta $0200,x
	pla 
	sta $0201,x
	lda #$00
	sta $0202,x
	pla 
	sta $0203,x
	lda $0617
	clc 
	adc #$04
	sta $0617
	inc $59
	lda $67
	and #$01
	beq Lbl_a347
	lda #$02
	cmp $59
	bne Lbl_a308

Lbl_a347:
	rts 

Lbl_a348:
	.byte $70,$78,$80,$88,$90,$98,$70,$78,$80,$88,$90,$98

Lbl_a354:
	.byte $58,$58,$58,$58,$58,$58,$d8,$d8,$d8,$d8,$d8,$d8

Lbl_a360:
	lda #$08
	sta $59
	lda #$dc
	sta $5a
	lda #$a3
	sta $5b
	ldx $0617
	ldy #$00

Lbl_a371:
	jsr Lbl_a3a1
	bcc Lbl_a37d
	iny 
	iny 
	iny 
	iny 
	jmp Lbl_a399

Lbl_a37d:
	lda ($5a),y
	sta $0200,x
	iny 
	lda ($5a),y
	sta $0201,x
	iny 
	lda ($5a),y
	sta $0202,x
	iny 
	lda ($5a),y
	sta $0203,x
	iny 
	inx 
	inx 
	inx 
	inx 

Lbl_a399:
	dec $59
	bne Lbl_a371
	stx $0617
	rts 

Lbl_a3a1:
	lda $67
	and #$01
	bne Lbl_a3a9
	clc 
	rts 

Lbl_a3a9:
	txa
	pha 
	tya 
	pha 
	lda $59
	sec 
	sbc #$01
	asl a 
	tax
	lda Lbl_a3cc,x
	sta $5f
	lda Lbl_a3cd,x
	sta $60
	lda #$a3
	pha 
	lda #$c6
	pha 
	jmp ($005f)

Lbl_a3c7:
	.byte $68,$a8,$68,$aa,$60

Lbl_a3cc:
	.byte $fc

Lbl_a3cd:
	.byte $a3,$0d,$a4,$1e,$a4,$2f,$a4,$40,$a4,$51,$a4,$62,$a4,$73,$a4,$bf
	.byte $05,$00,$28,$af,$06,$00,$50,$cf,$07,$00,$50,$bf,$08,$00,$70,$bf
	.byte $22,$00,$d0,$af,$06,$00,$a8,$cf,$07,$00,$a8,$bf,$08,$00,$88

Lbl_a3fc:
	lda $66
	cmp #$06
	bne Lbl_a40b
	lda $069e
	and #$10
	bne Lbl_a40b
	sec 
	rts 

Lbl_a40b:
	clc 
	rts 

Lbl_a40d:
	lda $66
	cmp #$05
	bne Lbl_a41c
	lda $069e
	and #$10
	bne Lbl_a41c
	sec 
	rts 

Lbl_a41c:
	clc 
	rts 

Lbl_a41e:
	lda $66
	cmp #$04
	bne Lbl_a42d
	lda $069e
	and #$10
	bne Lbl_a42d
	sec 
	rts 

Lbl_a42d:
	clc 
	rts 

Lbl_a42f:
	lda $66
	cmp #$04
	bcs Lbl_a43e
	lda $069e
	and #$10
	bne Lbl_a43e
	sec 
	rts 

Lbl_a43e:
	clc 
	rts 

Lbl_a440:
	lda $65
	cmp #$06
	bne Lbl_a44f
	lda $069e
	and #$10
	bne Lbl_a44f
	sec 
	rts 

Lbl_a44f:
	clc 
	rts 

Lbl_a451:
	lda $65
	cmp #$05
	bne Lbl_a460
	lda $069e
	and #$10
	bne Lbl_a460
	sec 
	rts 

Lbl_a460:
	clc 
	rts 

Lbl_a462:
	lda $65
	cmp #$04
	bne Lbl_a471
	lda $069e
	and #$10
	bne Lbl_a471
	sec 
	rts 

Lbl_a471:
	clc 
	rts 

Lbl_a473:
	lda $65
	cmp #$04
	bcs Lbl_a482
	lda $069e
	and #$10
	bne Lbl_a482
	sec 
	rts 

Lbl_a482:
	clc 
	rts 

Lbl_a484:
	lda #$00
	sta $53

Lbl_a488:
	ldx $53
	txa
	asl a 
	tay 
	lda Lbl_a500,y
	sta $61
	lda Lbl_a501,y
	sta $62
	lda Lbl_a500,y
	sta $63
	lda Lbl_a501,y
	sta $64
	ldx #$00

Lbl_a4a3:
	ldy #$00
	inx 
	txa
	dex 

Lbl_a4a8:
	cmp ($61),y
	beq Lbl_a4b4
	iny 
	cpy a:$0006
	bcc Lbl_a4a8
	ldy #$06

Lbl_a4b4:
	txa
	pha 
	lda $53
	eor #$01
	tax
	lda $7a,x		; p2 or p1 team, depending on X
	asl a 
	tax
	lda Lbl_a504,x	; index into real set of rosters
	sta $67
	lda Lbl_a505,x	; index into real set of rosters
	sta $68
	lda ($67),y
	tay 
	pla 
	tax
	lda $53
	bne Lbl_a4d6
	cpy #$00
	beq Lbl_a4d7

Lbl_a4d6:
	iny 

Lbl_a4d7:
	tya 
	sta $4d,x
	inx 
	cpx #$06
	bcc Lbl_a4a3
	ldy #$02
	ldx #$05

Lbl_a4e3:
	lda a:$004d,x
	sta ($63),y
	dex 
	dey 
	bpl Lbl_a4e3
	ldy #$03

Lbl_a4ee:
	lda a:$004d,x
	sta ($63),y
	iny 
	dex 
	bpl Lbl_a4ee
	inc $53
	lda $53
	cmp #$02
	bcc Lbl_a488
	rts 

Lbl_a500:
	.byte $f0

Lbl_a501:
	.byte $06,$f6,$06

Lbl_a504:
	.byte $16

Lbl_a505:		; real roster orders
	.byte $a5,$1c,$a5,$22,$a5,$28,$a5,$2e,$a5,$34,$a5,$3a,$a5,$40,$a5,$46
	.byte $a5
	;-----------------------------------;
	;type  A , D , C , B , F , E
	.byte $00,$03,$02,$05,$01,$04		; Team USA
	.byte $00,$04,$01,$02,$03,$05		; Pro All-Stars
	.byte $00,$02,$04,$05,$03,$01		; England
	.byte $00,$03,$01,$02,$05,$04		; India
	.byte $00,$05,$04,$01,$03,$02		; Iceland
	.byte $00,$01,$02,$03,$04,$05		; China
	.byte $00,$03,$02,$01,$05,$04		; Japan
	.byte $00,$05,$03,$04,$02,$01		; Kenya
	.byte $00,$02,$04,$01,$05,$03		; USSR (might not match)

Lbl_a54c:
	lda #$c6
	sta $02
	lda #$a6
	sta $03
	lda a:$007a		; P2 Team
	and #$7f
	beq Lbl_a55e
	sec 
	sbc #$01

Lbl_a55e:
	asl a 
	asl a 
	asl a 
	sta $04
	lda a:$007b		; P1 Team
	and #$7f
	beq Lbl_a56d
	sec 
	sbc #$01

Lbl_a56d:
	ora $04
	asl a 
	tax
	lda Lbl_a6ca,x
	sta $61
	lda Lbl_a6cb,x
	sta $62
	ldy #$00
	lda ($61),y
	sta $04
	iny 
	lda ($61),y
	sta $05
	iny 
	lda ($61),y
	sta $06
	iny 
	lda ($61),y
	sta $07
	iny 
	lda ($61),y
	sta $08
	iny 
	lda ($61),y
	sta $09
	jsr Lbl_a67b
	jsr Lbl_a5a1
	rts 

Lbl_a5a1:
	lda a:$007a		; P2 Team
	and #$7f
	cmp #$03
	beq Lbl_a5b2
	cmp #$07
	beq Lbl_a5b2
	ldx #$00
	beq Lbl_a5c5

Lbl_a5b2:
	lda a:$007b		; P1 Team
	and #$7f
	cmp #$03
	beq Lbl_a5c3
	cmp #$07
	beq Lbl_a5c3
	ldx #$02
	bne Lbl_a5c5

Lbl_a5c3:
	ldx #$04

Lbl_a5c5:
	lda Lbl_a669,x
	sta $61
	lda Lbl_a66a,x
	sta $62
	ldy #$00
	lda #$23
	ldx #$d0
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $2007		; PPUDATA
	lda $2007		; PPUDATA
	and #$3f
	ora ($61),y
	sta $02
	lda #$23
	ldx #$d0
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $02
	sta $2007		; PPUDATA
	iny 
	lda #$23
	ldx #$d1
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $2007		; PPUDATA
	lda $2007		; PPUDATA
	and #$cf
	ora ($61),y
	sta $02
	lda #$23
	ldx #$d1
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $02
	sta $2007		; PPUDATA
	iny 
	lda #$23
	ldx #$d4
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $2007		; PPUDATA
	lda $2007		; PPUDATA
	and #$3f
	ora ($61),y
	sta $02
	lda #$23
	ldx #$d4
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $02
	sta $2007		; PPUDATA
	iny 
	lda #$23
	ldx #$d5
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $2007		; PPUDATA
	lda $2007		; PPUDATA
	and #$cf
	ora ($61),y
	sta $02
	lda #$23
	ldx #$d5
	sta $2006		; PPUADDR
	stx $2006		; PPUADDR
	lda $02
	sta $2007		; PPUDATA
	rts 

Lbl_a669:
	.byte $6f

Lbl_a66a:
	.byte $a6,$73,$a6,$77,$a6,$80,$20,$c0,$30,$40,$10,$80,$20,$80,$20,$80
	.byte $20

Lbl_a67b:
	lda #$3f
	sta $2006		; PPUADDR
	lda #$00
	sta $2006		; PPUADDR
	ldy #$00

Lbl_a687:
	lda ($02),y
	sta $2007		; PPUDATA
	iny 
	cpy #$04
	bcc Lbl_a687
	ldy #$00

Lbl_a693:
	lda ($04),y
	sta $2007		; PPUDATA
	iny 
	cpy #$04
	bcc Lbl_a693
	ldy #$00

Lbl_a69f:
	lda ($06),y
	sta $2007		; PPUDATA
	iny 
	cpy #$04
	bcc Lbl_a69f
	ldy #$00

Lbl_a6ab:
	lda ($08),y
	sta $2007		; PPUDATA
	iny 
	cpy #$04
	bcc Lbl_a6ab
	lda #$3f
	sta $2006		; PPUADDR
	lda #$00
	sta $2006		; PPUADDR
	sta $2006		; PPUADDR
	sta $2006		; PPUADDR
	rts 

Lbl_a6c6:
	.byte $0c,$30,$00,$17

Lbl_a6ca:
	.byte $4a

Lbl_a6cb:
	.byte $a7,$4a,$a7,$50,$a7,$4a,$a7,$56,$a7,$4a,$a7,$5c,$a7,$56,$a7,$4a
	.byte $a7,$4a,$a7,$50,$a7,$4a,$a7,$56,$a7,$4a,$a7,$5c,$a7,$56,$a7,$62
	.byte $a7,$62,$a7,$68,$a7,$62,$a7,$6e,$a7,$62,$a7,$74,$a7,$6e,$a7,$4a
	.byte $a7,$4a,$a7,$50,$a7,$4a,$a7,$56,$a7,$4a,$a7,$5c,$a7,$56,$a7,$7a
	.byte $a7,$80,$a7,$86,$a7,$80,$a7,$8c,$a7,$7a,$a7,$92,$a7,$8c,$a7,$4a
	.byte $a7,$4a,$a7,$50,$a7,$4a,$a7,$56,$a7,$4a,$a7,$5c,$a7,$56,$a7,$98
	.byte $a7,$98,$a7,$9e,$a7,$98,$a7,$a4,$a7,$98,$a7,$aa,$a7,$a4,$a7,$7a
	.byte $a7,$80,$a7,$86,$a7,$80,$a7,$8c,$a7,$7a,$a7,$92,$a7,$8c,$a7,$b0
	.byte $a7,$b0,$a7,$b0,$a7,$b4,$a7,$b8,$a7,$b0,$a7,$bc,$a7,$b0,$a7,$b0
	.byte $a7,$c0,$a7,$b8,$a7,$b0,$a7,$b0,$a7,$b8,$a7,$b4,$a7,$b4,$a7,$b8
	.byte $a7,$b4,$a7,$bc,$a7,$b8,$a7,$b4,$a7,$c0,$a7,$b8,$a7,$b4,$a7,$b0
	.byte $a7,$bc,$a7,$bc,$a7,$b0,$a7,$b0,$a7,$bc,$a7,$b4,$a7,$b8,$a7,$bc
	.byte $a7,$bc,$a7,$bc,$a7,$bc,$a7,$c0,$a7,$b8,$a7,$bc,$a7,$b0,$a7,$b8
	.byte $a7,$c0,$a7,$b4,$a7,$b8,$a7,$c0,$a7,$bc,$a7,$b8,$a7,$c0,$a7,$c0
	.byte $a7,$b8,$a7,$c0,$a7
	; another set of flag palettes?
	.byte $0c,$30,$1c,$16		; USA, England, Iceland
	.byte $0c,$30,$27,$12		; India top
	.byte $0c,$30,$16,$2a		; India bottom, Kenya Top
	.byte $0c,$30,$37,$16		; China, Japan, USSR
	.byte $0c,$30,$16,$0f		; Kenya Top
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

Lbl_a800:
	.byte $00,$00,$01,$02,$03,$04,$05,$f6,$06,$fc,$06,$bf,$05,$c7,$05,$13
	.byte $a8,$1f,$a8,$cf,$05,$d4,$05,$d9,$05,$de,$05,$e3,$05,$e8,$05,$ed
	.byte $05,$f2,$05,$f7,$05,$fc,$05,$01,$06,$06,$06

Lbl_a82b:
	.byte $ff

Lbl_a82c:
	.byte $a9,$90,$a9,$ea,$a8

Lbl_a831:
	lda #$00
	ldy #$60

Lbl_a835:
	sta $0108,y
	dey 
	bne Lbl_a835
	bit $70
	bvs Lbl_a873	; branch if overflow set
	jsr Lbl_af19
	ldy #$03
	ldx #$00

Lbl_a846:
	tya 
	pha 
	lda $06f0,y
	jsr Lbl_a890
	sta $017a,x
	pla 
	tay 
	inx 
	iny 
	cpy #$06
	bne Lbl_a846
	ldy #$03
	ldx #$03

Lbl_a85d:
	tya 
	pha 
	lda $06f6,y
	jsr Lbl_a8b8
	sta $017a,x
	pla 
	tay 
	inx 
	iny 
	cpy #$06
	bne Lbl_a85d
	jsr Lbl_af19

Lbl_a873:
	lda a:$0070
	and #$60
	lsr a
	lsr a
	lsr a
	lsr a
	tay
	lda Lbl_a82b,y
	sta $57
	lda Lbl_a82c,y
	sta $58
	jmp ($0057)

Lbl_a88a:
	.byte $00,$04,$03,$02,$06,$05

Lbl_a890:
	stx $03
	tax
	lda Lbl_a800,x
	sta $02
	ldx #$0c

Lbl_a89a:
	lda Lbl_af01,x
	sta $00
	inx 
	lda Lbl_af01,x
	sta $01
	inx 
	ldy #$02
	lda ($00),y
	and #$07
	cmp $02
	bne Lbl_a89a
	txa
	lsr a
	sec 
	sbc #$01
	ldx $03
	rts 

Lbl_a8b8:
	stx $03
	tax
	lda Lbl_a800,x
	sta $02
	ldx #$00

Lbl_a8c2:
	lda Lbl_af01,x
	sta $00
	inx 
	lda Lbl_af01,x
	sta $01
	inx 
	ldy #$02
	lda ($00),y
	and #$07
	cmp $02
	bne Lbl_a8c2
	txa
	lsr a
	sec 
	sbc #$01
	ldx $03
	rts 

Lbl_a8e0:
	.byte $02,$10,$22,$30,$42,$50,$fd,$fe,$01,$02,$a2,$00,$bd,$86,$00,$30
	.byte $0b,$a8,$b9,$e0,$a8,$a8,$bd,$e6,$a8,$99,$08,$01,$e8,$e0,$04,$d0
	.byte $eb,$a9,$00,$85,$03,$85,$53,$a9,$57,$85,$4f,$a9,$ab,$85,$50,$a6
	.byte $03,$a9,$6f,$85,$51,$a9,$ab,$85,$52,$bd,$8a,$a8,$85,$02,$aa,$a6
	.byte $03,$ad,$ed,$06,$4a,$ca,$10,$fc,$90,$0e,$a5,$03,$85,$02,$e6,$02
	.byte $a9,$13,$85,$51,$a9,$a8,$85,$52,$20,$02,$ab,$e6,$03,$e6,$03,$e6
	.byte $53,$a9,$03,$c5,$53,$d0,$c8,$a9,$5a,$85,$4f,$a9,$ab,$85,$50,$a9
	.byte $00,$85,$53,$a9,$01,$85,$03,$a6,$03,$a9,$6f,$85,$51,$a9,$ab,$85
	.byte $52,$bd,$8a,$a8,$85,$02,$aa,$a6,$03,$ad,$ed,$06,$4a,$ca,$10,$fc
	.byte $90,$0e,$a9,$13,$85,$51,$a9,$a8,$85,$52,$a5,$03,$85,$02,$e6,$02
	.byte $20,$02,$ab,$e6,$03,$e6,$03,$e6,$53,$a9,$03,$c5,$53,$d0,$c8,$60
	.byte $20,$19,$af,$a9,$57,$85,$4f,$a9,$ab,$85,$50,$a9,$f0,$18,$69,$03
	.byte $85,$5c,$a9,$06,$69,$00,$85,$5d,$ad,$ed,$06,$85,$4d,$a9,$13,$85
	.byte $00,$a9,$a8,$85,$01,$ad,$7b,$00,$29,$0f,$85,$4e,$a9,$af,$85,$05
	.byte $a9,$0d,$85,$04,$20,$98,$aa,$a9,$5a,$85,$4f,$a9,$ab,$85,$50,$a9
	.byte $f6,$18,$69,$03,$85,$5c,$a9,$06,$69,$00,$85,$5d,$ad,$ee,$06,$85
	.byte $4d,$a9,$1f,$85,$00,$a9,$a8,$85,$01,$ad,$7a,$00,$29,$0f,$85,$4e
	.byte $a9,$af,$85,$05,$a9,$01,$85,$04,$20,$98,$aa,$20,$19,$af,$60

Lbl_a9ff:
	jsr Lbl_af19
	lda #$57
	sta $4f
	lda #$ab
	sta $50
	lda #$f0
	clc 
	adc #$03
	sta $5c
	lda #$06
	adc #$00
	sta $5d
	lda $06ed
	sta $4d			; $4d = value at $06ed
	lda #$13
	sta $00
	lda #$a8
	sta $01
	lda a:$007b		; P1 Team
	and #$0f
	sta $4e
	lda #$af
	sta $05
	lda #$0d
	sta $04
	jsr Lbl_aa98
	lda #$5a
	sta $4f
	lda #$ab
	sta $50
	lda #$f6
	clc 
	adc #$03
	sta $5c
	lda #$06
	adc #$00
	sta $5d
	lda #$00
	sta $4d
	lda a:$0076
	bpl Lbl_aa66
	lda $06ed
	sta $4d			; $4d = value at $06ed
	lda #$f0
	clc 
	adc #$03
	sta $5c
	lda #$06
	adc #$00
	sta $5d

Lbl_aa66:
	lda #$1f
	sta $00
	lda #$a8
	sta $01
	lda a:$007a		; P2 Team
	and #$0f
	sta $4e
	lda a:$0076
	bpl Lbl_aa89
	lda a:$007b		; P1 Team
	and #$0f
	sta $4e
	lda #$13
	sta $00
	lda #$a8
	sta $01

Lbl_aa89:
	lda #$af
	sta $05
	lda #$01
	sta $04
	jsr Lbl_aa98
	jsr Lbl_af19
	rts 

Lbl_aa98:
	lda #$00
	sta $53

Lbl_aa9c:
	ldy $53
	lda ($5c),y
	and #$07
	sta $02
	lda $00
	sta $51
	lda $01
	sta $52
	ldy $02
	lda Lbl_a800,y
	tay 
	lda $4e
	asl a 
	tax
	lda Lbl_aeac,x
	sta $04
	lda Lbl_aead,x
	sta $05
	lda ($04),y
	tay 
	lda $4d

Lbl_aac5:
	lsr a
	dey 
	bpl Lbl_aac5
	bcs Lbl_aadc
	lda $4e
	asl a 
	tay 
	lda Lbl_ab5d,y
	sta $51
	lda Lbl_ab5e,y
	sta $52
	jmp Lbl_aaf6

Lbl_aadc:
	ldy $02
	lda Lbl_a800,y
	tay 
	lda $4e
	asl a 
	tax
	lda Lbl_aeac,x
	sta $04
	lda Lbl_aead,x
	sta $05
	lda ($04),y
	sta $02
	inc $02

Lbl_aaf6:
	jsr Lbl_ab02
	inc $53
	lda #$03
	cmp $53
	bne Lbl_aa9c
	rts 

Lbl_ab02:
	ldy $02
	lda Lbl_a800,y
	asl a 
	tay 
	lda ($51),y
	sta $5a
	iny 
	lda ($51),y
	sta $5b
	ldy a:$0053
	lda ($4f),y
	sta $59
	jsr Lbl_ab1d
	rts 

Lbl_ab1d:
	ldy #$00
	ldx a:$0059

Lbl_ab22:
	lda ($5a),y
	sta $0108,x
	inx 
	iny 
	cpy #$05
	bne Lbl_ab22
	rts 

Lbl_ab2e:
	.byte $a9,$20,$8d,$06,$20,$a5,$4d,$18,$69,$40,$8d,$06,$20,$a5,$ff,$29
	.byte $fb,$85,$ff,$8d,$00,$20,$a0,$00,$a6,$4d,$b1,$4f,$8d,$07,$20,$9d
	.byte $08,$01,$e8,$c8,$c4,$51,$d0,$f2,$60,$03,$23,$43,$11,$31,$51

Lbl_ab5d:
	.byte $6f

Lbl_ab5e:		; names and such
	.byte $ab,$99,$ab,$c3,$ab,$ed,$ab,$17,$ac,$41,$ac,$95,$ac,$6b,$ac,$bf
	.byte $ac,$7b,$ab,$8a,$ab,$85,$ab,$80,$ab,$94,$ab,$8f,$ab
	;------------------------;
	.byte $e2,$d0,$dc,$00,$00		; Sam
	.byte $d9,$de,$d7,$dd,$00		; John
	.byte $dc,$d8,$da,$d4,$00		; Mike
	.byte $d1,$d8,$db,$db,$00		; Bill
	.byte $e1,$d0,$dd,$d3,$e8		; Randy
	.byte $e2,$e3,$d4,$e5,$d4		; Steve
	;------------------------;
	.byte $a5,$ab,$af,$ab,$b4,$ab,$b9,$ab,$aa,$ab,$be,$ab
	.byte $d9,$d0,$d2,$da,$00		; Jack
	.byte $e3,$de,$dc,$00,$00		; Tom
	.byte $d5,$e1,$d4,$d3,$00		; Fred
	.byte $d1,$d4,$dd,$00,$00		; Ben
	.byte $df,$d0,$e4,$db,$00		; Paul
	.byte $d3,$d0,$e5,$d8,$d3		; David
	;------------------------;
	.byte $cf,$ab,$e8,$ab,$d4,$ab,$e3,$ab,$d9,$ab,$de,$ab
	.byte $d9,$d0,$dc,$d4,$e2		; James
	.byte $e2,$d2,$de,$e3,$e3		; Scott
	.byte $d7,$d4,$dd,$e1,$e8		; Henry
	.byte $e1,$de,$d6,$d4,$e1		; Roger
	.byte $df,$d4,$e3,$d4,$e1		; Peter
	.byte $d2,$db,$d8,$d5,$d5		; Cliff
	;------------------------;
	.byte $f9,$ab,$03,$ac,$08,$ac,$fe,$ab,$12,$ac,$0d,$ac,$e1,$d0,$d9,$d8,$e5
	.byte $e2,$e6,$d0,$dc,$d8,$d1,$d0,$e3,$d0,$00,$da,$e4,$dc,$d0,$e1,$e9
	.byte $d0,$d8,$db,$00,$d0,$da,$d1,$d0,$e1,$23,$ac,$32,$ac,$3c,$ac,$37
	.byte $ac,$2d,$ac,$28,$ac,$d7,$d4,$db,$d6,$d8,$da,$dd,$e4,$e3,$00,$d7
	.byte $d0,$dd,$e2,$00,$d1,$d9,$de,$e1,$dd,$dd,$d8,$db,$e2,$00,$d6,$d8
	.byte $e2,$db,$d8,$4d,$ac,$52,$ac,$57,$ac,$5c,$ac,$61,$ac,$66,$ac,$e6
	.byte $d0,$dd,$d6,$00,$d7,$e2,$d8,$d4,$d7,$db,$d8,$00,$00,$00,$d2,$d7
	.byte $de,$e4,$00,$dc,$d0,$de,$00,$00,$e3,$e2,$d0,$d8,$00,$77,$ac,$86
	.byte $ac,$7c,$ac,$90,$ac,$81,$ac,$8b,$ac,$e8,$d4,$dc,$d8,$00,$d1,$e6
	.byte $de,$d6,$d8,$d4,$e8,$de,$00,$00,$dc,$e6,$d0,$d8,$00,$de,$d1,$d0
	.byte $00,$00,$e3,$d0,$d7,$d0,$00,$a1,$ac,$ba,$ac,$b5,$ac,$ab,$ac,$b0
	.byte $ac,$a6,$ac,$d5,$e4,$d9,$d8,$00,$de,$d3,$d0,$00,$00,$e2,$d0,$e3
	.byte $de,$00,$d7,$d8,$dd,$de,$00,$d7,$de,$dd,$d3,$d0,$d0,$de,$da,$d8
	.byte $00,$cb,$ac,$da,$ac,$d5,$ac,$d0,$ac,$e4,$ac,$df,$ac,$d1,$de,$e1
	.byte $d8,$e2,$e8,$d0,$da,$de,$e5,$d8,$e5,$d0,$dd,$00,$d8,$d6,$de,$e1
	.byte $00,$e5,$de,$db,$d5,$00,$df,$d0,$e5,$d4,$db

Lbl_ace9:
	bit a:$0070
	bvc Lbl_acf1
	jmp Lbl_ae58

Lbl_acf1:
	lda $017a
	sta $03
	jsr Lbl_aef4
	ldy #$04
	lda ($00),y
	sta $4d
	jsr Lbl_ae7b
	sta $010a
	lda $017b
	sta $03
	jsr Lbl_aef4
	ldy #$04
	lda ($00),y
	sta $4e
	jsr Lbl_ae7b
	sta $012a
	lda $017c
	sta $03
	jsr Lbl_aef4
	ldy #$04
	lda ($00),y
	sta $4f
	jsr Lbl_ae7b
	sta $014a
	lda $017d
	sta $03
	jsr Lbl_aef4
	ldy #$04
	lda ($00),y
	sta $50
	jsr Lbl_ae7b
	sta $0118
	lda $017e
	sta $03
	jsr Lbl_aef4
	ldy #$04
	lda ($00),y
	sta $51
	jsr Lbl_ae7b
	sta $0138
	lda $017f
	sta $03
	jsr Lbl_aef4
	ldy #$04
	lda ($00),y
	sta $52
	jsr Lbl_ae7b
	sta $0158
	ldy #$00

Lbl_ad6b:
	lda $4d
	ldx #$f9
	sec 
	sbc #$08
	beq Lbl_ad76
	bcs Lbl_ad8b

Lbl_ad76:
	lda $4d
	ldx #$f9
	sec				; set carry
	sbc #$04
	beq Lbl_ad81
	bcs Lbl_ad89

Lbl_ad81:
	ldx #$00
	lda $4d
	beq Lbl_ad8b
	ldx #$fa

Lbl_ad89:
	lda #$00

Lbl_ad8b:
	sta $4d
	txa
	sta $0110,y
	lda $4e
	ldx #$f9
	sec 
	sbc #$08
	beq Lbl_ad9c
	bcs Lbl_adb1

Lbl_ad9c:
	lda $4e
	ldx #$f9
	sec 
	sbc #$04
	beq Lbl_ada7
	bcs Lbl_adaf

Lbl_ada7:
	ldx #$00
	lda $4e
	beq Lbl_adb1
	ldx #$fa

Lbl_adaf:
	lda #$00

Lbl_adb1:
	sta $4e
	txa
	sta $0130,y
	lda $4f
	ldx #$f9
	sec 
	sbc #$08
	beq Lbl_adc2
	bcs Lbl_add7

Lbl_adc2:
	lda $4f
	ldx #$f9
	sec 
	sbc #$04
	beq Lbl_adcd
	bcs Lbl_add5

Lbl_adcd:
	ldx #$00
	lda $4f
	beq Lbl_add7
	ldx #$fa

Lbl_add5:
	lda #$00

Lbl_add7:
	sta $4f
	txa
	sta $0150,y
	lda $50
	ldx #$f9
	sec 
	sbc #$08
	beq Lbl_ade8
	bcs Lbl_adfd

Lbl_ade8:
	lda $50
	ldx #$f9
	sec 
	sbc #$04
	beq Lbl_adf3
	bcs Lbl_adfb

Lbl_adf3:
	ldx #$00
	lda $50
	beq Lbl_adfd
	ldx #$fa

Lbl_adfb:
	lda #$00

Lbl_adfd:
	sta $50
	txa
	sta $011e,y
	lda $51
	ldx #$f9
	sec 
	sbc #$08
	beq Lbl_ae0e
	bcs Lbl_ae23

Lbl_ae0e:
	lda $51
	ldx #$f9
	sec 
	sbc #$04
	beq Lbl_ae19
	bcs Lbl_ae21

Lbl_ae19:
	ldx #$00
	lda $51
	beq Lbl_ae23
	ldx #$fa

Lbl_ae21:
	lda #$00

Lbl_ae23:
	sta $51
	txa
	sta $013e,y
	lda $52
	ldx #$f9
	sec 
	sbc #$08
	beq Lbl_ae34
	bcs Lbl_ae49

Lbl_ae34:
	lda $52
	ldx #$f9
	sec 
	sbc #$04
	beq Lbl_ae3f
	bcs Lbl_ae47

Lbl_ae3f:
	ldx #$00
	lda $52
	beq Lbl_ae49
	ldx #$fa

Lbl_ae47:
	lda #$00

Lbl_ae49:
	sta $52
	txa
	sta $015e,y
	iny 
	cpy #$08
	bne Lbl_ae55
	rts 

Lbl_ae55:
	jmp Lbl_ad6b

Lbl_ae58:
	lda $0323		; Player 1/6 Energy (Bean Ball)
	sta $4d
	lda $0393		; Player 2/6 Energy (Bean Ball)
	sta $4e
	lda $0403		; Player 3/6 Energy (Bean Ball), or Player 2-2 Energy
	sta $4f
	lda $035b		; Player 4/6 Energy (Bean Ball)
	sta $50
	lda $03cb		; Player 5/6 Energy (Bean Ball), or Player 2-3 Energy
	sta $51
	lda $043b		; Player 6/6 Energy (Bean Ball), or Player 2-1 Energy
	sta $52
	ldy #$00
	jmp Lbl_ad6b

Lbl_ae7b:
	ldy #$02
	lda ($00),y
	sta $02
	and #$20
	beq Lbl_ae99
	ldy #$00
	lda ($00),y
	ldx #$00
	and #$40
	beq Lbl_ae97
	ldx #$fd
	lda $02
	bmi Lbl_ae97
	ldx #$fe

Lbl_ae97:
	txa
	rts 

Lbl_ae99:
	lda $03
	cmp $8a
	bne Lbl_aea2
	lda #$fb
	rts 

Lbl_aea2:
	cmp $8d
	bne Lbl_aea9
	lda #$fb
	rts 

Lbl_aea9:
	lda #$00
	rts 

Lbl_aeac:
	.byte $be

Lbl_aead:		; (??) and character positions
	; this might be the one that does something else
	.byte $ae,$c4,$ae,$ca,$ae,$d0,$ae,$d6
	.byte $ae,$dc,$ae,$e2,$ae,$e8,$ae,$ee,$ae
	;type  A , D , C , B , F , E
	.byte $00,$03,$02,$01,$05,$04		; Team USA/Nekketsu
	.byte $00,$02,$03,$04,$01,$05		; Pro All Stars/Hanazono
	.byte $00,$05,$01,$04,$02,$03		; England
	.byte $00,$02,$03,$01,$05,$04		; India
	.byte $00,$03,$05,$04,$02,$01		; Iceland
	.byte $00,$01,$02,$03,$04,$05		; China
	.byte $00,$03,$01,$05,$02,$04		; Japan
	.byte $00,$05,$04,$02,$03,$01		; Kenya
	.byte $00,$04,$02,$01,$05,$03		; USSR

Lbl_aef4:
	asl a 
	tax
	lda Lbl_af01,x
	sta $00
	lda Lbl_af02,x
	sta $01
	rts 

Lbl_af01:
	.byte $1f

Lbl_af02:
	.byte $03,$57,$03,$8f,$03,$c7,$03,$ff,$03,$37,$04,$6f,$04,$a7,$04,$df
	.byte $04,$17,$05,$4f,$05,$87,$05

Lbl_af19:
	lda $06f3
	ldx $06f5
	sta $06f5
	stx $06f3
	lda $06f9
	ldx $06fb
	sta $06fb
	stx $06f9
	rts 

Lbl_af32:
	sta $52
	and #$7f
	tay 
	lda #$1b
	sta $4f
	lda #$b0
	sta $50
	ldx $06ed
	lda $52
	bpl Lbl_af5a	; branch if positive
	lda #$29
	sta $4f
	lda #$b0
	sta $50
	ldx $06ee		; load $06ee
	lda a:$0070
	and #$20
	bne Lbl_af5a
	ldx #$00

Lbl_af5a:
	txa
	and #$bf
	tax
	stx $51
	txa
	lsr a
	and #$40
	ora $51
	sta $51
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda #$00
	sta $2001		; set PPUMASK
	ldx #$00

Lbl_af78:
	lda a:$004d,x
	pha 
	inx 
	cpx #$14
	bne Lbl_af78
	tya 
	pha 
	lda Lbl_b004,y
	jsr Lbl_fa65
	pla 
	cmp #$03
	bne Lbl_af9d
	; write $B1 to $223D
	lda #$22
	sta $2006		; PPUADDR
	lda #$3d
	sta $2006		; PPUADDR
	lda #$b1
	sta $2007		; PPUDATA

Lbl_af9d:
	ldx #$13

Lbl_af9f:
	pla 
	sta a:$004d,x
	dex 
	bpl Lbl_af9f
	lda #$00
	sta $4d

Lbl_afaa:
	lsr $51
	bcc Lbl_afe5
	lda $4d
	asl a 
	tay 
	lda Lbl_b00e,y
	sta $2006		; PPUADDR
	lda Lbl_b00d,y
	sta $2006		; PPUADDR
	lda $ff			; load game PPU control
	and #$fb		; mask: b11111011 (mask out vram increment)
	sta $ff			; set game PPU control
	sta $2000		; set PPUCTRL
	lda $4d
	asl a 
	tay 
	lda ($4f),y
	sta $53
	iny 
	lda ($4f),y
	sta $54
	ldx $4d
	lda Lbl_b037,x
	tax
	ldy #$00

Lbl_afdc:
	lda ($53),y
	sta $2007		; PPUDATA
	iny 
	dex 
	bne Lbl_afdc

Lbl_afe5:
	inc $4d
	lda $4d
	cmp #$07
	bne Lbl_afaa
	jsr Lbl_fca0
	jsr Lbl_fe8a
	jsr sub_UpdateOAM	; update OAM
	lda #$08		; 00001000: show background
	sta $2001		; set PPUMASK
	lda #$00		; reset ppu scroll
	sta $2005		; PPUSCROLL
	sta $2005		; PPUSCROLL
	rts 

Lbl_b004:
	.byte $1a,$1b,$1c,$1d,$1e,$1f,$20,$21,$22

Lbl_b00d:
	.byte $8b

Lbl_b00e:
	.byte $20,$92,$20,$99,$20,$2b,$22,$32,$22,$39,$22,$42,$20,$cf,$05,$d4
	.byte $05,$d9,$05,$de,$05,$e3,$05,$e8,$05,$bf,$05,$ed,$05,$f2,$05,$f7
	.byte $05,$fc,$05,$01,$06,$06,$06,$c7,$05

Lbl_b037:		; mostly free extra space?
	.byte $05,$05,$05,$05,$05,$05,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$ee,$eb,$ff,$ea,$ea,$ea,$ea,$ea,$ea,$ea,$ea,$ea,$ea,$ea,$ea
	.byte $ea,$ea,$04,$e8,$bf,$e8,$bf,$e8,$bf
