; Super Dodge Ball-specific stuff
;<zero page>
;$17		?? (referenced a lot, continually written to)
;$1A		??
;$1E		Kunio/Sam general animation on main menu

;$20		?? used for player 1 direction (controller) in bean ball?
;$21		??
;$23		??
;$26		?? [banks 1,3,6]
;$28		?? (no longer used?)
;$2D		??

;$31		??
;$37		??

;$42		??
;$4D		dynamic pointer to something or other (used a LOT. 6 of the 8 banks use it in some way.)
;$4E		may or may not be used as ball speed in game. normally the high byte of dynamic pointer above
;$4F		??

;$50		??
;$51		??
;$52		??
;$53		??
;$54		??

;$55,$56	Current PPU address?? (see Lbl_d346 in bank 7)

;$57		?? (something to do with super shots? but not always) [banks 1,3,7]
;In bank 4, it's used as part of an indirect jump along with $58.
;$58		?? sometimes part of indirect jump w/$57 (in bank 4) [banks 1,3,4,7]

;$5D		CPU Order (check on change position screen)

;$60		??

;$61		change position menu cursor P1 Y (pixels; temp)
;$61 may also be Sprite X Scroll value. (in menus?)

;$62		change position menu cursor P2 Y (pixels; temp)
;$63		??
;$64		??
;$65		change position P1 selection counter ($00-$07; $07=finished)
;$67		??
;$69		MMC1 mapper data [bank 7 only]
;$6B		??
;$6E		??
;$6F		Number of Human Players (Bean Ball: $01-$04) [banks 4 and 7]

;$70		?? (0x00 in world cup, 0x20 in versus play, 0x40 in bean ball)
;$70 & #$01 means you're in a menu, I think.
;used in pretty much every bank but 2 (US version, lol) and 0 (music player)

;$71		Current Stage (world cup) [banks 1,3,4,7]
;$72		??
;$73		??
;$74		??
;$75		??
;$76		Shadow Team Match? [banks 4,6,7]
;$78		?? [banks 1,3,4,6,7]
;$79		Current Music (in-match)
;$7A		Player 2 Team
;$7B		Player 1 Team

;$80		Players alive on P2 Team (normal)/CPU team (bean ball)
;$81		Players alive on P1 Team (normal)/Player team (bean ball)
;$86		??
;$8A		??
;$8E		??

;$90		??
;$91		??
;$92		Player 1 X position 1 (bean ball)
;$93		Player 1 X position 2 (bean ball)
;$94		Player 1 Y position (bean ball)

;-----------;
;$9E		Player 2-3 X position 1
;$9F		Player 2-3 X position 2
;$A0		Player 2-3 Y Position
;-----------;
;$A2		Player 2-2 X position 1
;$A3		Player 2-2 X position 2
;$A4		Player 2-2 Y position
;-----------;
;$A6		Player 2-1 X position 1
;$A7		Player 2-1 X position 2
;$A8		Player 2-1 Y position
;-----------;
;$AA		Player 1-4 (Top) X position 1
;$AB		Player 1-4 (Top) X position 2
;$AC		Player 1-4 (Top) Y position?
;-----------;
;$AE		Player 1-4 (Bottom) X position 1
;$AF		Player 1-4 (Bottom) X position 2
;$B0		Player 1-4 (Bottom) Y position
;-----------;
;$B2		Player 1-4 (Side) X position 1
;$B3		Player 1-4 (Side) X position 2
;$B4		Player 1-4 (Side) Y position
;-----------;
;$B6		Player 1-3 X position 1
;$B7		Player 1-3 X position 2
;$B8		Player 1-3 Y position
;-----------;
;$BA		Player 1-2 X position 1
;$BB		Player 1-2 X position 2
;$BC		Player 1-2 Y position
;-----------;
;$BE		Player 1-1 X position 1
;$BF		Player 1-1 X position 2
;$C0		Player 1-1 Y position
;-----------;

;$C2		??
;$C3		Sprite X Scroll value (#$20 on title screen)
;$C4		Sprite Y Scroll value?
;$CD		Shot Type ($00-$15)
;$CE		Attack (power level $00-$40) [banks 1,3,6,7]
;$CF		Ball stabilization counter?
;$D0		Ball ??
;$D1		Ball ??
;$D4		Ball Speed ($00-$FF)

;$E0		Ball X position 1
;$E1		Ball X position 2
;$E2		Ball X position 3
;$E3		Ball Y position 1
;$E4		Ball Y position 2
;$E6		Ball Height 1
;$E7		Ball Height 2
;$EC		??

;$F5		Player 1 Input (trigger)
;$F6		Player 2 Input (trigger)
;$F7		Player 1 Input (state)
;$F8		Player 2 Input (state)
;$F9		??
;$FA		??
;$FB		?? (used during joystick [strobes/reads(?)])
;$FC		BG Y Scroll value (typically 0)
;$FD		BG X Scroll value (0x28 min, 0xD8 max)
;$FE		game PPU mask
;$FF		game PPU control

;<elsewhere>
;$0100		?? [bank 7 only]
;$0101		??
;$0102		??
;$0103		current PRG bank? [bank 7 only]
;$0230		change position menu cursor ??

;$034D		?? (0x02 in a match, 0x00 in menus?)

; In-Match Data
; (-0x0150 offset for 2P vals from 1P; 0x38 difference between players)
;-------------------------------------;
;$03CB		Player 2-3 Energy
;$03D2		Player 2-3 Movement Direction
;-------------------------------------;
;$0403		Player 2-2 Energy
;$040A		Player 2-2 Movement Direction
;-------------------------------------;
;$043B		Player 2-1 Energy
;$0442		Player 2-1 Movement Direction
;-------------------------------------;
;$051B		Player 1-3 Energy
;$0522		Player 1-3 Movement Direction
;$053C		Player 1-3 Jump Distance
;$053F		Player 1-3 Jump Height
;-------------------------------------;
;$0553		Player 1-2 Energy
;$055A		Player 1-2 Movement Direction
;$0574		Player 1-2 Jump Distance
;$0577		Player 1-2 Jump Height
;-------------------------------------;
;$058A		??
;$058B		Player 1-1 Energy
;$0592		Player 1-1 Movement Direction
;$05AC		Player 1-1 Jump Distance
;$05AF		Player 1-1 Jump Height (0xC0 = actual jump)
;-------------------------------------;

; Bean Ball In-Match Data (0x70 player offset)
;-------------------------------------;
;$0323		Player 1/6 Energy
;$032A		Player 1 Movement Direction?

;$0338		Player 1 Movement Direction?
;$0341		Player 1 Movement Direction?
;-------------------------------------;
;$035b		Player 2/6 Energy
;-------------------------------------;
;$0393		Player 3/6 Energy
;-------------------------------------;
;$03cb		Player 4/6 Energy
;-------------------------------------;
;$0403		Player 5/6 Energy
;-------------------------------------;
;$043b		Player 6/6 Energy
;-------------------------------------;

;$044F		defeating team captain = game over (2p) if set to 0x00

;$0587		Bean Ball Menu Cursor? (#players, then p1 player)
;$0588		p2 bean ball player cursor (temp)
;$0589		p2 bean ball player cursor (temp)
;$058A		VS Mode Team Cursor P1 (temp var); p4 bean ball player cursor (temp)
;$058B		VS Mode Team Cursor P2 (temp var)
;$058F		number of human players?

;$0592		bean ball menu thing 3
;$059F		defeating team captain = game over (1p) if set to 0x00

;$05B3		??
;$05BF		unsure of it, but might be where renamer data lives? [bank 4]

;$0617		index into OAM?

;$066E		"Ball Form"

;$067A		??
;$067B		??

;$069B		??
;$069C		Character Color (all non-VS modes)
;$069D		dupe of Character Color (all non-VS modes)
;$069E		probably a frame counter (title menu cursor blinking, among others)

;$06A4		?? (only used in Lbl_8287 in bank 3)
;$06AE		Current left/sprite CHR bank [banks 4,7]
;$06AF		(Current left/sprite CHR bank dupe?) [banks 4,7]

;$06B0		?? [bank 7 only]
;$06B1		game mode
;$06B2		game pause (#$40 == pause; #$80 is set here sometimes; wtf)
;$06B4		??
;$06B6		??

;$06D9		current PRG bank

;$06EA		difficulty level
;$06EB		ball color
;$06EC		(ball color dupe?)
;$06ED		sometimes used by itself, other times used as a jumping point
;$06EE		?? (only referenced like 5-6 times, mostly in bank 4)
;$06EF		I want to say this has something to do with your team order.

;$06FC		VS Mode Team Colors
;$06FD		??

;<music engine>
;$0700		??
;$0701		current song (and some other things?)
;$0714		pause(/stop?) playback
;$0717		music speed
;$0718		??
;$0719		pulse 1 related
;$071A		pulse 2 related
;$071B		triangle related
;$071C		noise related
;$0731		pulse 1 related
;$0732		pulse 2 related
;$0733		triangle related
;$0734		noise related

;<anything in $0700-$07FF that's not the music engine>
;$07E0		shadow team flashing effect (does not trigger team itself; see $76)
;$07E1		related to shadow team flashing effect? [bank 7 only, 11 references]
;$07F0		"KUMAGAI" string for reset detection.

;<in other banks>
;$BFF9		hey, what's my current bank number?